
function AppspaceNodeClient(){
    this.prevNodeId = '';
    this.prevServer = '';
    this.path = '';
    this.RunAdvanceDeviceManagement();

}

AppspaceNodeClient.prototype.RunAdvanceDeviceManagement = function(){

    var args = process.argv;
    this.path = args[2];

    var AppspaceLogger = require("./modules/util/log");
    /** @type {AppspaceLogger} */
    this.logger = new AppspaceLogger(this.path);
    this.logger.log('INFO','START AppspaceNodeClient');

    var localconfig = this.path + '/adm.config';
    fs.readFile(localconfig,EventHandler.CreateEventHandler(this,this.onReceiveConfigHandler));

    //var nodedatpath = this.path + '/node.dat';
    //fs.readFile(nodedatpath,EventHandler.CreateEventHandler(this,this.onReceiveNodeDatHandler));

}

AppspaceNodeClient.prototype.onReceiveConfigHandler = function(calle,err,data){
    if (err != null && err != undefined){
        calle.prevNodeId = '';
        calle.prevServer = '';
    }else{
        var datafile = data.toString();
        var arrs = datafile.split(';');
        var l = arrs.length;
        for (var i = 0 ; i < l ; i++){
            var arr = arrs[i];
            var kvps = arr.split('=');
            if (kvps.length == 2){
                switch(kvps[0].toLowerCase()){
                    case 'nodeid':
                        calle.prevNodeId = kvps[1];
                        break;
                    case 'server':
                        calle.prevServer = kvps[1];
                        break;
                }
            }
        }
    }

    var nodedatpath = calle.path + '/node.dat';
    fs.readFile(nodedatpath,EventHandler.CreateEventHandler(calle,calle.onReceiveNodeDatHandler));
}

AppspaceNodeClient.prototype.deletefiles = function(){
    var deployed = this.path + '/deployedtask.cache';
    var deployedExec = this.path + '/deployedtaskexecuted.cache';
    var tqtime = this.path + '/taskqueuetime';
    fs.unlink(deployed,function(err,data){});
    fs.unlink(deployedExec,function(err,data){});
    fs.unlink(tqtime,function(err,data){});
}

AppspaceNodeClient.prototype.onReceiveNodeDatHandler = function(calle,err,data){
    var dataString = data.toString();
    var datas = dataString.split('\n');

    var server = datas[2];
    var player = datas[0];

    if (server != calle.prevServer || player != calle.prevNodeId){
        calle.deletefiles();
    }

    var localconfig = calle.path + '/adm.config';
    fs.writeFile(localconfig,'nodeid=' + player + ';server=' + server);

    var AdvanceDeviceManagement = require("./modules/adm/main");
    var adm = new AdvanceDeviceManagement(calle.path);
    adm.setLogger(calle.logger);
    adm.start(datas[2],datas[0],datas[1]);
}


var fs = require('fs');
var EventHandler = require('./modules/util/eventhandler')
var appspacenodeclient = new AppspaceNodeClient();