/**
 * ...
 * @author husain
 */
var ws = require('ws');
var EventHandler = require('../../util/eventhandler');
var DeviceType = require('../../util/devicetype');
var fs = require('fs');

function AppspaceLogService(){
	var remotePort = 60109;
	var remoteServer = null;
	var filepath = null;
	this.setConfig = function(config){
		switch(config.deviceType){
			case DeviceType.DMP4310:
			case DeviceType.DMP4400:
				filepath = "/tmp/ftproot/usb_1/Logs/externallog.txt";
				break;
			case DeviceType.Edge300:
			case DeviceType.Edge340:
				filepath = "/apps/nexus2/Logs/externallog.txt";
				break;
		}
	};
	
	this.start = function(){
		remoteServer = new ws.Server({port:remotePort,host:'127.0.0.1'});
		remoteServer.on('connection',EventHandler.CreateEventHandler(this,this.onConnectionEstablishedHandler));
		//remoteServer.on('message',EventHandler.CreateEventHandler(this,this.onMessageHandler));
	};
	
	this.onConnectionEstablishedHandler = function(calle,connection){
		calle.onConnectionEstablished(connection);
	};
	
	this.onConnectionEstablished = function(connection){
		var connectionName = connection._socket.remoteAddress + ":" + connection._socket.remotePort;
		console.log('logservice receive subscriber :' + connectionName);
		connection.on('message',EventHandler.CreateEventHandler(this,this.onMessageHandler));
		
	};
	
	this.onMessageHandler = function(calle,data){
		console.log('logservice receive message');
		calle.onMessage(data);
	};
	
	this.onMessage = function(data){
		console.log('logservice receive message:' + data.toString());
		data = data.toString();
		if (filepath != null){
			console.log('writing to:' + filepath);
			fs.appendFile(filepath,data + "\n",function(err){});
		}
	};
}

exports.AppspaceLogService = AppspaceLogService;