/**
 * Created by syed.husain on 8/20/2014.
 */
var fs = require('fs');
var EventHandler = require('../../util/eventhandler.js');
var xml2js = require('xml2js');

function Script(){
    this.scriptpath = null;
    this.onFilesRetrievedEventHandler = null;
    this.contentPath = null;
    this.basePath = null;

    this.start = function(){
        var arguments = process.argv;
        var l = arguments.length;
        var action = null;
        var scriptfile = null;
        var scriptfileold = null;

        for (var i = 2 ; i < l ; i++){
            var arg = arguments[i];
            if (arg.toLowerCase().indexOf('scriptpath') != -1){
                this.scriptpath = arg.split('scriptpath=').join('').split('"').join('').split('\'').join('');
                this.scriptpath = this.scriptpath.split('\\').join('/');
                if (this.scriptpath.charAt(this.scriptpath.length - 1) != '/')
                    this.scriptpath += '/';
            } else if (arg.toLowerCase().indexOf('operation') != -1){
                action = arg.toLowerCase().split('operation=').join('').split('"').join('').split('\'').join('');
            }else if (arg.toLowerCase().indexOf('oldscriptfile') != -1) {
                scriptfileold = arg.split('oldscriptfile=').join('').split('"').join('').split('\'').join('');
            }
            else if (arg.toLowerCase().indexOf('scriptfile') != -1){
                scriptfile = arg.split('scriptfile=').join('').split('"').join('').split('\'').join('');
            }else if (arg.toLowerCase().indexOf('contentpath') != -1){
                this.contentPath = arg.split('contentpath=').join('').split('"').join('').split('\'').join('');
                this.contentPath = this.contentPath.split('\\').join('/');
                if (this.contentPath.charAt(this.contentPath.length - 1) != '/')
                    this.contentPath += '/';
            }
        }

        if (action == null){
            this.onFail();
            return;
        }

        switch(action){
            case 'retrievefilesfromscript':
                this.retrieveFilesFromScript(this.scriptpath + scriptfile);
                break;
            case 'retrievesmarthublisting':
                this.retrieveSmarthubListing(this.scriptpath + scriptfile);
                break;
            case 'retrievecdnlisting':
                this.retrieveCDNListing(this.scriptpath + scriptfile);
                break;
            case 'retrievefilestodownload':
                this.retrieveFilesToDownload(this.scriptpath + scriptfile);
                break;
            case 'retrievefilestodelete':
                this.retrieveFilesToDelete(this.scriptpath + scriptfile,this.scriptpath + scriptfileold);
                break;
        }
    };

    this.retrieveFilesFromScript = function(scriptfile){
        this.onFilesRetrievedEventHandler = this.onFilesRetrievedHandler;
        this.retrieveFiles(scriptfile);
    };

    this.onFilesRetrievedHandler = function(realFileListings){
        realFileListings.push('');//bash doesn't read the last line
        fs.writeFile(this.scriptpath + 'nodejsoutput',realFileListings.join('\n'),function(err){});
    };

    this.retrieveFilesToDownload = function(scriptfile){
        this.onFilesRetrievedEventHandler = this.onFilesToDownloadRetrievedHandler;
        this.retrieveFiles(scriptfile);
    };

    this.onFilesToDownloadRetrievedHandler = function(filesfromscript){
        var files = this.listFilesFromDirectory(this.contentPath, []);
        var filesFromSystem = {};
        for (var i = 0 ; i < files.length; i++){
            var f = files[i].split(this.contentPath).join('');
            filesFromSystem[f.toLowerCase()] = true;
        }
        var res = [];
        for (var i = 0 ; i < filesfromscript.length; i++){
            if (filesFromSystem[filesfromscript[i].toLowerCase()] == null)
                res.push(filesfromscript[i]);
        }
        res.push('');//bash doesn't read the last line
        console.log('files to download done')
        fs.writeFile(this.scriptpath + 'nodejsoutput',res.join('\n'),function(err){});

    };

    this.retrieveFilesToDelete = function(newscriptfile,oldscriptfile){

        this.onFilesRetrievedEventHandler = EventHandler.CreateEventHandler(this,this.onNewFilesToDeleteRetrievedHandler,{new:newscriptfile,old:oldscriptfile});
        this.retrieveFiles(newscriptfile);
    };

    this.onNewFilesToDeleteRetrievedHandler = function(calle,state,filesfromscript){
        calle.onNewFilesToDeleteRetrieved(state.new,state.old,filesfromscript);
    };

    this.onNewFilesToDeleteRetrieved = function(newscript,oldscript,filesfromnewscript){
        this.onFilesRetrievedEventHandler = EventHandler.CreateEventHandler(this,this.onOldFilesToDeleteRetrievedHandler,{new:newscript,old:oldscript,newFiles:filesfromnewscript});
        this.retrieveFiles(oldscript);
    };

    this.onOldFilesToDeleteRetrievedHandler = function(calle,state,filesfromscript){
        calle.onOldFilesToDeleteRetrieved(state.newscript,state.oldscript,state.newFiles,filesfromscript);
    };

    this.onOldFilesToDeleteRetrieved = function(newscript,oldscript,newfiles,oldfiles){
        var files = this.listFilesFromDirectory(this.contentPath, []);
        var filesFromSystem = {};
        for (var i = 0 ; i < files.length; i++){
            var f = files[i].split(this.contentPath).join('');
            filesFromSystem[f.toLowerCase()] = true;
        }

        var merged = {};

        for (var i = 0 ; i < newfiles.length; i++){
            merged[newfiles[i].toLowerCase()] = true;
        }

        for (var i = 0 ; i < oldfiles.length; i++){
            if (merged[oldfiles[i].toLowerCase()] == null)
                merged[oldfiles[i].toLowerCase()] = true;
        }
        var res = [];
        for (var key in filesFromSystem){
            if (merged[key.toLowerCase()] == null)
                res.push(key);
        }
        res.push('');//bash doesn't read the last line
        console.log('files to delete done')
        fs.writeFile(this.scriptpath + 'nodejsoutput',res.join('\n'),function(err){});
    };

    this.listFilesFromDirectory = function(basePath,filesFromDir){

        if (basePath.indexOf('\\') != -1)
            basePath = basePath.split('\\').join('/');
        if (basePath.charAt(basePath.length - 1) != '/')
            basePath += '/';

        var files = [];
        try {
            files = fs.readdirSync(basePath);
        }catch (e){
            return filesFromDir;
        }
        var l = files.length;
        for (var i = 0 ; i < l; i++){
            var file = basePath + files[i];
            var stat = fs.lstatSync(file);
            if (stat.isDirectory() == true){
                filesFromDir = this.listFilesFromDirectory(file,filesFromDir);
            }
            else{
                filesFromDir.push(file);
            }
        }


        return filesFromDir;

    };

    this.retrieveFiles = function(scriptfile){
        fs.readFile(scriptfile,EventHandler.CreateEventHandler(this,this.onRetrieveFilesScriptReadHandler));
    }

    this.onRetrieveFilesScriptReadHandler = function(calle,err,data){
        calle.onRetrieveFilesScriptRead(err,data);
    };

    this.onRetrieveFilesScriptRead = function(err,data){
        if (err != null && this.onFilesRetrievedEventHandler != null) {
            this.onFilesRetrievedEventHandler([]);
            return;
        }

        data = data.toString();
        data = this.prepareRawScriptForXML(data);
        var parser = new xml2js.Parser();
        parser.parseString(data,EventHandler.CreateEventHandler(this,this.onRetrieveFilesXMLParsedHandler));

    };

    this.onRetrieveFilesXMLParsedHandler = function(calle,err,result){
        calle.onRetrieveFilesXMLParsed(err,result);
    }

    this.onRetrieveFilesXMLParsed = function(err,result){
        if (err != null){
            this.onFail();
            return;
        }
        var realFileListings = this.retrieveFileListingsFromXML(result);
        if (this.onFilesRetrievedEventHandler != null){
            this.onFilesRetrievedEventHandler(realFileListings);
        }
    };

    this.prepareRawScriptForXML = function(data){
        data = data.replace(/ELEMENT DATA/g,'ELEMENT_DATA');
        data = data.replace(/FOLDER LISTINGS/g,'FOLDER_LISTINGS');
        data = data.replace(/NUM FILES/g,'NUM_FILES');
        data = data.replace(/TOTAL SIZE/g,'TOTAL_SIZE');

        var start = data.indexOf("<ID>ApplicationXML_");
        var end = data.indexOf("</TABLE>",start);

        var tmp1 = data.substring(0,start);
        var tmp2 = data.substring(end);

        data = tmp1 + tmp2;
        data = data.replace(/&/g,'&amp;');
        data = '<root>\n'+data+'\n</root>';

        return data;
    };

    this.retrieveFileListingsFromXML = function(xml){
        var filelistings = {};
        var folders = xml.root.FOLDER_LISTINGS;
        if (folders != undefined && folders != null) {
            var foldersl = folders.length;
            for (var i = 0; i < foldersl; i++) {
                var folder = folders[i].FOLDER;

                if (folder == undefined || folder == null)
                    continue;

                var folderl = folder.length;
                for (var j = 0; j < folderl; j++) {
                    var files = folder[j].FILES;

                    if (files == null || files == undefined)
                        continue;

                    var path = folder[j].PATH[0];
                    var filesl = files.length;
                    for (var k = 0; k < filesl; k++) {
                        var fileinfo = files[k].FILE;

                        if (fileinfo == null || fileinfo == undefined)
                            continue;

                        var fileinfol = fileinfo.length;
                        for (var m = 0; m < fileinfol; m++) {
                            var name = fileinfo[m].NAME[0];
                            if (name.indexOf("_thumbnail") == -1)
                                var fullName = path + "\\" + name;
                            fullName = fullName.replace(/C:\\FastNetV2\\/g, '');
                            fullName = fullName.replace(/c:\\fastnetv2\\/g, '');
                            fullName = fullName.replace(/UG Media/g, 'ugmedia');
                            fullName = fullName.replace(/ug media/g, 'ugmedia');
                            fullName = fullName.replace(/DataSource/g, 'datasource');
                            fullName = fullName.replace(/SoftwarePackages/g, 'softwarepackages');
                            fullName = fullName.replace(/\\/g, '/');
                            filelistings[fullName.toLowerCase()] = fullName;
                        }
                    }
                }

            }
        }

        var realFileListings = [];

        for(var x in filelistings) {
            realFileListings.push(filelistings[x]);
        }

        return realFileListings;
    }

    this.retrieveSmarthubListing = function(scriptfile){
        fs.readFile(scriptfile,EventHandler.CreateEventHandler(this,this.onRetrieveSmarthubScriptReadHandler));
    };

    this.onRetrieveSmarthubScriptReadHandler = function(calle,err,data){
      calle.onRetrieveSmarthubScriptRead(err,data);
    };

    this.onRetrieveSmarthubScriptRead = function(err,data) {
        if (err != null) {
            this.onFail();
            return;
        }

        data = data.toString();
        var tables = this.retrieveContentDistributionTable(data);
        var smarthubs = [];
        var smarthubDatas = tables['smarthub'];
        if (smarthubDatas != null) {
            var linesl = smarthubDatas.length;

            for (var i = 0; i < linesl; i++) {
                var smarthubData = smarthubDatas[i];
                if (smarthubData == '')
                    continue;

                smarthubs.push(smarthubData);
            }
        }
        smarthubs.push('');//bash doesn't read the last line
        fs.writeFile(this.scriptpath + 'nodejsoutput',smarthubs.join('\n'),function(err){});
    };

    this.retrieveCDNListing = function(scriptfile){
        fs.readFile(scriptfile,EventHandler.CreateEventHandler(this,this.onRetrieveCDNScriptReadHandler));
    };

    this.onRetrieveCDNScriptReadHandler = function(calle,err,data){
        calle.onRetrieveCDNScriptRead(err,data);
    };

    this.onRetrieveCDNScriptRead = function(err,data){
        if (err != null){
            this.onFail();
            return;
        }

        data = data.toString();
        var tables = this.retrieveContentDistributionTable(data);
        var cdnDatas = tables['cdn'];
        var cdns = [];
        if (cdnDatas != null) {
            var linesl = cdnDatas.length;

            for (var i = 0; i < linesl; i++) {
                var cdnData = cdnDatas[i];

                if (cdnData == '')
                    continue;

                cdns.push(cdnData);
            }
        }
        cdns.push('');//bash doesn't read the last line
        fs.writeFile(this.scriptpath + 'nodejsoutput',cdns.join('\n'),function(err){});
    };

    this.retrieveContentDistributionTable = function(data){
        var start = data.toLowerCase().indexOf("<id>contentdistribution_");
        start = data.toLowerCase().indexOf("</id>",start);
        var end = data.toLowerCase().indexOf("</table>",start);
        data = data.substring(start + 5,end);

        var splitter = '\r\n';
        if (data.indexOf('\r\n') == -1)
            splitter = '\n';
        data = data.substring(splitter.length,data.length - splitter.length);
        var datas = data.split(splitter);
        return this.parseDataTable(datas);
    };

    this.parseDataTable = function(arrays){
        var l = arrays.length;
        var res = {};
        var tableLineLT = new Object();

        if (l <= 0)
            return null;

        //process the table header
        var headers = arrays[0].split(',');
        var ll = headers.length;
        var previousTable = null;
        for (var j = 0 ; j < ll ; j++){
            var kvps = headers[j].split('=');
            if (kvps.length == 2){
                var key = kvps[0].toString().toLowerCase();
                tableLineLT[key] = new Object();
                tableLineLT[key].Start = parseInt(kvps[1],10) + 1;
                if (previousTable != null)
                    tableLineLT[previousTable].End = parseInt(kvps[1],10) - 1;
                previousTable = key;
            }
        }

        for (var key in tableLineLT){
            if (res[key] == null)
                res[key] = [];
            var end = tableLineLT[key].End;
            if (end == null)
                end = l - 1;
            for (var i = tableLineLT[key].Start ; i <= end; i++){
                res[key].push(arrays[i]);
            }
        }
        return res;
    };

    this.onFail = function(){
        fs.writeFile(this.scriptpath + 'nodejsoutput','fail',function(err){});
    };
}


var script = new Script();
script.start();
