/**
 * Created by syed.husain on 014 14 04 2014.
 */
var ws = require('ws');
var EventHandler = require('../../util/eventhandler.js');

function RemoteSocket(){
    this.remotePort = 55537;
    this.subscribers = new Object();

    this.isStarted = false;
}

RemoteSocket.prototype.subscribe = function(func){
    var d = new Date();
    this.subscribers[d.getTime() + '_subscriber'] = func;
}


RemoteSocket.prototype.start = function(){
    console.log('Appspace Remote Socket Service started');
    this.remoteServer = new ws.Server({port:this.remotePort});
    this.remoteServer.on('connection',EventHandler.CreateEventHandler(this,this.onConnectionEstablishedHandler));
    this.isStarted = true;
}

RemoteSocket.prototype.onConnectionEstablishedHandler = function(calle,connection){
    calle.onConnectionEstablished(connection);
}

RemoteSocket.prototype.onConnectionEstablished = function(connection){
    var calle = this;

    var connectionName = connection._socket.remoteAddress + ":" + connection._socket.remotePort;
    connection.name = connectionName;
    var request = connection.upgradeReq.url;
    request = decodeURIComponent(request);
    /*if (request.indexOf('/') >= 0)
        request = request.split('/').join('');*/
    connection.close();
    this.sendToSubscribers(request);

}

RemoteSocket.prototype.sendToSubscribers = function(data){
    if (data.indexOf('/') == 0)
        data = data.substring(1);

    for(var key in this.subscribers){
        if (this.subscribers[key] != null)
            this.subscribers[key](data);
        else
            delete this.subscribers[key];

    }
}

RemoteSocket.prototype.stop = function(){
    console.log('Appspace Remote Socket Service stopped');
    if (this.remoteServer != null)
        this.remoteServer.close();
    this.isStarted = false;
}

exports.RemoteSocket = RemoteSocket;