function requestUtil (){
	this.request = require('request');
	this.usingProxy = false;
}

requestUtil.prototype.setProxy = function(URL){
	if (URL != null || URL != "") {
		this.request.defaults({proxy: URL});
		this.usingProxy = true;
	} else {
		//setting no proxy
		this.request.defaults({proxy: ""});
		this.usingProxy = false;
	}
}

requestUtil.prototype.createOptionsObject = function(){
	var requestParams = {
		url: "",
		port: "",
		headers: {},
		body: "",
		successCallback: null,
		failCallback: null,
		state: null,
		authentication : { username:null, password:null},
		timeout: 30000,
		method: 'GET',
		rejectUnauthorized: false
	};
	return requestParams;
}

requestUtil.prototype.makeRequest = function(requestParams){
	var options = {
		url: requestParams.url,
		port: requestParams.port,
		method: requestParams.method,
		timeout: requestParams.timeout,
		headers: requestParams.headers,
		rejectUnauthorized: false,
	};

	if (requestParams.authentication.username !== null && requestParams.authentication.password !== null){
		var auth = 'Basic ' + new Buffer(requestParams.authentication.username + ':' + requestParams.authentication.password).toString('base64');
		options.headers['Authorization'] = auth;
	}
	
	if(requestParams.body != null && requestParams.body != ""){
		options.body = requestParams.body;
		options.headers['Content-Length'] = options.body.length;
	}

	this.request(options, function(err,res,body){
		if ( err != null ){
			if(requestParams.failCallback != null)
				requestParams.failCallback(err, requestParams.state);
		}
		else {
			if(requestParams.successCallback != null)
				requestParams.successCallback(res, body, requestParams.state);
		}

	});
}

var RequestUtil = new requestUtil();
module.exports = RequestUtil;