#!/bin/sh
_tempPath="/tmp/appspace"
logfile=$_tempPath/appspace-reso.log
lastres=""
lastrot=""
while true
do
	sleep 15
	screeninfo="$(curl -s -X GET -k https://127.0.0.1/api/v3/screen)"
	
	if [ "$screeninfo" = "" ] ; then
		continue
	fi
	
	screenres=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).DVI1.current_resolution' "$screeninfo")
	screenrot=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).DVI1.current_rotation' "$screeninfo")
	
	if [ "$screenres" = "" ] || [ "$screenrot" = "" ] ; then
		continue
	fi
	
	if [ "$lastres" = "" ] || [ "$lastrot" = "" ] ; then
		lastres="$screenres"
		lastrot="$screenrot"
		continue
	fi
	
	if [ "$screenres" = "$lastres" ] && [ "$screenrot" = "$lastrot" ] ; then
		:
	else
		d=`date`
		echo "$d - Before : $lastres ($lastrot)" >> $logfile
		echo "$d - After  : $screenres ($screenrot)" >> $logfile
		sleep 5
		echo "$d - Killing chrome as resolution/rotation changes" >> $logfile
		killall -2 chrome
		lastres="$screenres"
		lastrot="$screenrot"
	fi
done
