#!/bin/bash

#NOD Download Manager
#
#�2012 Nexus Media Inc.
#All rights reserved.
#
#Warning : This software program is protected by copyright law  and international treaties.
#Unauthorized reproduction or distribution of this program, or any portion of it, may result in 
#severe civil and criminal penalties, and will be prosecuted to the maximun extend possible
#under the law.
#
#For more information, please visit http://appspace.nexusondemand.com/app/eula.htm
#or contact us at enquiries@nexusondemand.com

renice 5 -p $$
dmversion="`cat /apps/nexus2/internal-version.dat`"
_appSpaceURL="http://appspace.nexusondemand.com"
_deviceType=""
_smarthubURL=""
_CDNURL=""
_contentURL=""
_scriptHandlerURL=""
_timeStampHandlerURL=""
_syncStatusHandlerURL=""
_addPropertyHandlerURL=""
_getPropertyHandlerURL=""
_getSmarthubServerHandlerURL=""
_playerID=""
_baseApplicationPath="/apps/nexus2"
_contentRepoPath="$_baseApplicationPath/contentrepo"
_tempDownloadPath="$_baseApplicationPath/Temp Downloads"
_dataSourcePath="$_baseApplicationPath/DataSources"
_elementPath="$_baseApplicationPath/Elements"
_logPath="$_baseApplicationPath/Logs"
_tempPath="/tmp/appspace"
_heartbeatFile="$_tempPath/heartbeat"
_dmHeartbeatFile="$_tempPath/dmheartbeat"
_scriptTempFile=""
_scriptFile=""
_timeStampFile=""
_mediaHandlerURL=""
_filesToDelete=""
_filesDownloadedSuccessfully=0
_filesDownloadedFailed=0
_inSync=false
_lastContentTimestamp=""
_lastSoftwareUpateimestamp=""
_syncInterval=30
_sendInSync="false"
_doSoftwareUpdate=false
_spScriptVersion=""
_softwarePackagesInfo=""
_oldFiles=""
_newFiles=""
_rebootTime="23:00"
_versionSentOnStartup=false
_downloadmaxspeed=""
_syncschedule=""
_defaultSleep=60
_heartbeatTimeoutCount=1
_contentSyncEnabled="true"
_watchdogEnabled="true"
_memoryWatchEnabled="true"
_memoryLimit=1500000
_deviceUsername=""
_devicePassword=""
_smarthubList=""
_cdnList=""
_previousExternalStorage="false"
#Used for internal method calling 
REPLY=""
_templogpath="$_tempPath"
_useResumeDownload="false"
_syncNotificationEnable="true"
_ignoreOfflineSmarthub="true"
_rebootEvent="0"
_lastRebootEventValue=""
_chromeMemoryTotal=0
_chromeMemoryCount=0
_ACTIVECDN=""
_syncscheduleFailCount=0
function KillChrome(){
	#kill -2 $(pidof chrome)
	killall -2 chrome
}

function Reboot(){
	Log "About to reboot. Moving log file to $_logPath"
	cp -f $_templogpath/downloadmanagerlog.txt $_logPath/downloadmanagerlog.txt
	
	if [ -f /apps/nexus2/rebootscript.sh ] ; then
		/bin/bash /apps/nexus2/rebootscript.sh		
	else
		KillChrome
		sleep 1
		local d=$(date +%m/%d/%y-%T)
		echo "$d: Running normal reboot." >> $_logPath/downloadmanagerlog.txt
		reboot
		sleep 10
		d=$(date +%m/%d/%y-%T)
		echo "$d: Device doesn't reboot on normal reboot command. Running force reboot." >> $_logPath/downloadmanagerlog.txt
		reboot -n -f
	fi
	exit
}

function GetIPAddress(){
	#clear reply
	REPLY=""
	#get ip address from ifconfig
	local ipraw=`ifconfig | grep -i inet | grep -v inet6 | grep -v 127.0.0.1`
	#string the first title
	ipraw=`echo $ipraw | sed 's|inet addr:||'`
	#get the index of Bcast: which is the next title
	local index=`awk -v a="$ipraw" -v b="Bcast:" 'BEGIN{print index(a,b)}'`
	#substring from the first character until Bcast
	index=$(($index-1))
	ipraw=`awk -v a="$ipraw" -v b="$index" 'BEGIN{print substr(a,0,b)}'`
	#strip any spaces
	ipraw=`echo $ipraw | sed 's/ *$//g'`
	ProcessData "$ipraw"
	ipraw="$_REPLY"
	REPLY="$ipraw"
}

function GetMACAddress(){
	REPLY=""
	
	local macraw=`ifconfig | grep -i eth0`
	macraw=`echo $macraw | sed 's|eth0||'`
	macraw=`echo $macraw | sed 's|Link encap:Ethernet||'`
	macraw=`echo $macraw | sed 's|HWaddr||'`
	macraw=`echo $macraw | sed 's/ *$//g'`
	ProcessData "$macraw"
	macraw="$_REPLY"
	REPLY="$macraw"
}

function GetDeviceFirmware()
{
	REPLY=""
	local dfirmware=""
	if [ -f /scripts/cisco_env.sh ] ; then
		dfirmware=`cat /scripts/cisco_env.sh | grep -i FS_VERSION`
		dfirmware=`echo $dfirmware | sed 's|export FS_VERSION=||'`
	else
		dfirmware=`cat /etc/*-release | grep -i VERSION=`
		dfirmware=`echo $dfirmware | sed 's|VERSION=||g'`
		dfirmware=`echo $dfirmware | sed 's|"||g'`
	fi
	
	REPLY="$dfirmware"
}

function FatalError() {
	echo "Fatal error: ${1}"
	exit 1;
}

function Log() {
	
	[ -d _templogpath ] && : || mkdir -p $_templogpath
	
	[ "$_lastLogCheck" = "" ] && _lastLogCheck=$(date)
	
	if [[ -d "${_logPath}" && ! -L "${_logPath}" ]] ; then
		echo -n ""
	else 
		mkdir "$_logPath"
		echo "Log path does not exist. Creating: $_logPath"
		
	fi
	
	
	local d=$(date +%m/%d/%y-%T)
	if [ "$2" = "true" ] ; then
		echo "$d: ${1}" > "$_templogpath/downloadmanagerlog.txt"
	else
		echo "$d: ${1}" >> "$_templogpath/downloadmanagerlog.txt"
	fi
	echo "$d: ${1}"
	
}

function EchoArray() {
	declare -a array
	array=("${!1}")

	#Iterate through array and echo
	for i in "${array[@]}"
	do	
		echo "$i"		
	done
	return
}

function GetSyncSchedule()
{
	_getPropertyHandlerURL="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=getproperty&key=CDNAgent.SyncSchedule&type=player&id=$_playerID"
	Log "Retrieve player sync schedule : $_getPropertyHandlerURL"
	#local ts2=$(wget -qO- "$_getPropertyHandlerURL")
	local ts2=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=getproperty&key=CDNAgent.SyncSchedule&type=player&id=$_playerID")
	if [[ -z "${ts2}" ]] ; then		
		Log "No player sync schedule"
		_REPLY=""
	else
		Log "Player sync schedule retrieved : $ts2"
		_REPLY="$ts2"
	fi
}

function CheckSyncSchedule()
{
	_REPLY="true"	
	if [ "$_syncschedule" = "" ]; then
		_REPLY="true"
	else
		Log "Check content sync schedule"
		local dayoftheweek=$(date +%w)
		local currenttime=$(date +%R)
		local currenttime=`echo "$currenttime" | sed 's/:00//g'`
		local openindex=0
		local closeindex=0
		local timerange=""
		local vartemp="$_syncschedule"
		local dow=""
		local stime=""
		local etime=""
		local commaindex=0
		
		while [ ${#vartemp} != 0 ]; do
			
			#parse the sync schedule
			openindex=`expr index "$vartemp" {`
			closeindex=`expr index "$vartemp" }`
			timerange=`expr substr "$vartemp" $(($openindex+1)) $(($closeindex-$openindex-1))`
			vartemp=`expr substr "$vartemp" $(($closeindex+2)) $((${#vartemp}-$closeindex))`
			
			#parse the timerange
			commaindex=`expr index "$timerange" ,`
			dow=`expr substr "$timerange" 1 $(($commaindex-1))`
			timerange=`expr substr "$timerange" $(($commaindex+1)) $((${#timerange}-$commaindex))`
			commaindex=`expr index "$timerange" ,`
			stime=`expr substr "$timerange" 1 $(($commaindex-1))`
			timerange=`expr substr "$timerange" $(($commaindex+1)) $((${#timerange}-$commaindex))`
			etime="$timerange"
			
			#check validity. Even if only 1 timerange is valid, consider the sync schedule is valid
			
			if [ "$dow" = "7" -o "$dow" = "$dayoftheweek" ]; then
				rangestarthour=`expr substr "$stime" 1 2`
				rangeendhour=`expr substr "$etime" 1 2`
				currenthour=`expr substr "$currenttime" 1 2`
				if [ $currenthour -ge $rangestarthour -a $currenthour -lt $rangeendhour ] ; then
					_REPLY="true"
					break
				else
					_REPLY="false"
				fi
			else
				_REPLY="false"
			fi
			
		done
	fi	
}

function ProcessData()
{
	local procDataPath="$_tempPath/process.data"
	local message="$1"
	touch "$procDataPath"
	echo "$message" > "$procDataPath"
	local procData=""
	dos2unix "$procDataPath" > /dev/null
	while read processdataline
	do
		procData="$processdataline"
	done < "$procDataPath"
	
	_REPLY="$procData"								
	rm -rf "$procDataPath"
}


function CheckLogFile() {
	#Truncate Log file if too large
	echo "Checking Log File: $_templogpath/downloadmanagerlog.txt"
	if [ -f "$_templogpath/downloadmanagerlog.txt" ] ; then	
		OLDIFS=$IFS
		line=`stat -t "$_templogpath/downloadmanagerlog.txt"`
		unset TEMPARR
		IFS=' ' read -ra TEMPARR <<< "$line"
		local logSize="${TEMPARR[1]}"
		IFS=$OLDIFS	
		echo "Log File size: $logSize"
		if [ ${logSize} -gt 30240000 ]
		then
			rm -r "$_templogpath/downloadmanagerlog.txt"
			echo "Deleting log file"
		fi
	else
		echo "Log File does not exist: $_templogpath/downloadmanagerlog.txt"
	fi
	
	echo "Checking Log File: $_logPath/downloadmanagerlog.txt"
	if [ -f "$_logPath/downloadmanagerlog.txt" ] ; then	
		OLDIFS=$IFS
		line=`stat -t "$_logPath/downloadmanagerlog.txt"`
		unset TEMPARR
		IFS=' ' read -ra TEMPARR <<< "$line"
		local logSize="${TEMPARR[1]}"
		IFS=$OLDIFS	
		echo "Log File size: $logSize"
		if [ ${logSize} -gt 30240000 ]
		then
			rm -r "$_logPath/downloadmanagerlog.txt"
			echo "Deleting log file"
		fi
	else
		echo "Log File does not exist: $_logPath/downloadmanagerlog.txt"
	fi
}

function LoadConfiguration() {
	
	_playerID=""	
	_scriptFile="DMscript.txt"
	_scriptTempFile="debugScript.txt"
	_timeStampFile="DMapptimestamp.js"
	#_syncInterval=30
	#10240000

	CheckLogFile
	
	local lineOffset=0
	local dmUsage="false";
	_previousExternalStorage="false"
	while read -r line
	do
		#echo $lineOffset
		if [ $lineOffset == 0 ] ; then
			_playerID=$line
		elif [ $lineOffset == 2 ] ; then
			_appSpaceURL=$line
		elif [ $lineOffset == 1 ] ; then
			_deviceType=`echo $line | tr "[:upper:]" "[:lower:]"`
		fi
		if [[ "$line" = "downloadmanager="* ]] ; then
			dmUsage="$line"
			dmUsage=`echo "$dmUsage" | sed 's|downloadmanager=||g'`
		fi
		if [ "$(echo $line | grep -i externalstorage)" != "" ] ; then
			_previousExternalStorage=$(echo $line | sed 's/externalstorage=//g')
		fi
		lineOffset=$(($lineOffset+1))
	done < "$_baseApplicationPath/node.dat"
	
	#Determine if content sync is in use	
	if [ "$dmUsage" = "false" ]
	then
		Log "Disable Content Syncing via Download manager"
		_contentSyncEnabled="false"
	else
		Log "Content Syncing via Download manager"
		_contentSyncEnabled="true"
	fi
	
	if [ "$_playerID" != "" ] ; then
		if [ $_versionSentOnStartup == false ]; then
			local versiontosend="$dmversion"
			
			if [ -e "$_baseApplicationPath/version.inf" ]; then
				versiontosend=`cat "$_baseApplicationPath/version.inf"`
				versiontosend=`echo "$versiontosend" | sed 's/Edge Player=//g'`
				versiontosend=`echo "$versiontosend" | sed 's/edge player=//g'`
			else
				versiontosend="$dmversion"
				echo "Edge Player=$versiontosend" > "$_baseApplicationPath/version.inf"
			fi	
			
			local geturl="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=getproperty&key=Player.Software.Version&type=player&id=$_playerID"
			Log "Retrieving : $geturl"
			local ts2=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=getproperty&key=Player.Software.Version&type=player&id=$_playerID")			
			Log "Receive $ts2"
			
			if [ "$ts2" != "$versiontosend" ] ; then
				local sendurl="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=setproperty&key=Player.Software.Version&value=$versiontosend&type=player&id=$_playerID"
				Log "Send version info : $sendurl"
				ts2=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=setproperty&key=Player.Software.Version&value=$versiontosend&type=player&id=$_playerID")
			else
				Log "Server version ($ts2) is the same local version ($versiontosend), skipping version send"
			fi		
			
			_versionSentOnStartup=true
		fi
	fi
	
	_scriptHandlerURL="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=script&id="
	_timeStampHandlerURL="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=timestamp&id="
	_syncStatusHandlerURL="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=insync&id="
	
	_mediaHandlerURL="/medianet/fastnetdata/"
	_getSmarthubServerHandlerURL="$_appSpaceURL/integrationwebservices/SmartHubHandler.ashx?query=player.getsmarthubip&pid="
	
	Log "AppSpace URL: $_appSpaceURL"
	Log "Player ID: $_playerID"
	Log "ContentRepo:  $_contentRepoPath"
	Log "Sync Interval:  $_syncInterval"
	
	#Log "Script Handler URL: $_scriptHandlerURL"
	#Log "Timestmap Handler URL: $_timeStampHandlerURL"
	#Log "Sync Statux Handler URL: $_syncStatusHandlerURL"
	#Log "Media Handler Handler URL: $_mediaHandlerURL"

	#For testing always delete content repo REMOVE LATER :P 
	#rm -r "$_contentRepoPath"

	#Create Content Repo Folder if does not exist
	if [[ -d "${_contentRepoPath}" && ! -L "${_contentRepoPath}" ]] ; then
		:
	else 
		Log "Content Repo Path does not exist: $_contentRepoPath"
		mkdir "$_contentRepoPath"
	fi 
	chmod a+rw "$_contentRepoPath"

	#Uncommented for release 5.0.3
	#Delete Temp Download Path
	if [[ -d "${_tempDownloadPath}" && ! -L "${_tempDownloadPath}" ]] ; then		
		rm -r "$_tempDownloadPath"
	fi
	
	if [[ -d "${_dataSourcePath}" && ! -L "${_dataSourcePath}" ]] ; then		
		:
	else
		Log "Data Sources does not exist : $_dataSourcePath"
		mkdir "$_dataSourcePath"
	fi
	
	if [[ -d "${_elementPath}" && ! -L "${_elementPath}" ]] ; then		
		:
	else
		Log "Elements path does not exist : $_elementPath"
		mkdir "$_elementPath"
	fi
	
	#Create Temp Download Path
	if [ -d "$_tempDownloadPath" ]; then
		:
	else
		mkdir "$_tempDownloadPath"	
		chmod a+rw "$_tempDownloadPath"
	fi
}

function CheckTimeStamp() {
	REPLY=""
	#Concat to create complete request
	local request="${_timeStampHandlerURL}${_playerID}"
	if [ "$_smarthubURL" = "" ] ; then
		:
	else
		request="$_smarthubURL/smarthubservice/ConfigScriptHandler.ashx?operation=timestamp&id=$_playerID"
	fi
	
	Log "Checking TimeStamp: ${request}"

	#Download timestamp for Player	
	#local ts=$(wget -qO- "$request")
	local ts=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=timestamp&id=$_playerID")
	#echo $script

	#Check if a script was returned
	if [ -z "${ts}" ] ; then		
		Log "Failed to get server timestamp"
	else
		Log "Server TimeStamp: $ts"
		REPLY=$ts
	fi
}

function SendInSync() {
	REPLY=""
	local ts="${1}"	

	#Concat to create complete request
	local request="${_syncStatusHandlerURL}${_playerID}"
	#echo ${request} and ${ts}
	#request=`echo ${request}/${ts}`

	Log "Sending InSync Content Status: $request"

	#Download timestamp for Player
	#local ts=$(wget -qO- "$request")
	local ts=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=insync&id=$_playerID")

	#Check if a script was returned
	if [ -z "${ts}" ] ; then		
		Log "Failed to send insync status"
		REPLY="false"
	else
		REPLY="true"
	fi
}

function GetFilePath() {
	REPLY=""
	local fileName=$1
	local fileNoPath=""
	local bckSlashIndex=`expr index "$fileName" "/"`

	#strip out subfolders
	if [ $bckSlashIndex -gt 0 ] ; then
		fileNoPath="${fileName##*/}"
	else
		#strip out subfolders for \		
		fileNoPath="${fileName##*\\}"
	fi	
	local fileDiff=`expr ${#fileName} - ${#fileNoPath}`	
	local filePath=${fileName:0:$fileDiff}
	REPLY=$filePath	
	
}

function GetFileName() {
	REPLY=""
	local filePath=$1
	local fileNoPath;
	local bckSlashIndex=`expr index "$filePath" "/"`
	if [ $bckSlashIndex -gt 0 ] ; then
		#strip out subfolders for /
		fileNoPath="${1##*/}"	
	else
		#strip out subfolders for \		
		fileNoPath="${1##*\\}"					
	fi	
	REPLY=$fileNoPath		
}

function SendDownloadInitStatus(){

	if [ "$_syncNotificationEnable" = "false" ] ; then
		return
	fi

	local counter="$1"
	
	local serviceUrl="$_appSpaceURL/api/v1/appspace/networks/transfers/$_playerID/init/$counter"
	Log "Sending init content download status to Appspace : $serviceUrl"
	
	local ts2=$(curl -fsLk --connect-timeout 30 --url "$serviceUrl")
	
	if [[ -z "${ts2}" ]] ; then
		Log "Failed to send init content download status"
	else
		Log "Init content download status sent"
	fi
}

function SendDownloadStatus(){

	if [ "$_syncNotificationEnable" = "false" ] ; then
		return
	fi

	local currentindex="$1"
	local status="$2"
	local filename="$3"
	
	local serviceUrl="$_appSpaceURL/api/v1/appspace/networks/transfers/$_playerID/$currentindex,$filename/$status"
	Log "Sending download status : $serviceUrl"
	
	local ts2=$(curl -fsLk --connect-timeout 30 --url "$serviceUrl")
	
	if [[ -z "${ts2}" ]] ; then
		Log "Failed to send download status"
	else
		Log "Download status sent"
	fi
}

function DownloadFile() { 	
	REPLY=""

	local srcFile="$1"
	local dstFile="$2"
	local current="$3"
	local total="$4"
	local tmpDstFile="$dstFile.`date +%s`"
	
	#Get filename for dst
	GetFileName "$tmpDstFile"
	local tmpDstFileNoPath=$REPLY

	#Get filepath for dst
	GetFilePath "$dstFile"
	local dstPath="$_contentRepoPath/$REPLY"

	GetFileName "$dstFile"
	local dstFileName=$REPLY
	
	#echo "Dest: $dstFile  - $dstPath -$tmpDstFileNoPath"
	

	#Move to temp download path
	pushd "$_tempDownloadPath" > /dev/null
	
	local currentindex=$(($current - 1))
	SendDownloadStatus "$currentindex" "Started" "$dstFileName"
	
	downloadthis="$srcFile"
	downloadthis=`echo "$downloadthis" | sed 's| |%20|g'`
	
	if [ "$_downloadmaxspeed" = "" ]; then
		Log "($current/$total) Downloading File: $downloadthis"
		curl -fsLk --connect-timeout 30 -o "$tmpDstFileNoPath" "$downloadthis"
	else
		Log "($current/$total) Downloading File: $downloadthis with $_downloadmaxspeed""Bps limit"
		curl -fsLk --connect-timeout 30 -o "$tmpDstFileNoPath" "$downloadthis" --limit-rate `echo "$_downloadmaxspeed"`
	fi
	
	
	
	if [ $? -ne 0 ]
	then
		Log "Error downloading file: $srcFile"
		let _filesDownloadedFailed=$_filesDownloadedFailed+1
		SendDownloadStatus "$currentindex" "Failed" "$dstFileName"
		#Return to original path
		popd > /dev/null
		return;
	else
		Log "File downloaded: $downloadthis"
		#Return to original path
		popd > /dev/null
	fi

	#Create destination file path if does not exist
	if [[ -d "${dstPath}" && ! -L "${dstPath}" ]] ; then	
		chmod a+rw "$dstPath"
	else
		echo "Create $dstPath"
		mkdir -p "$dstPath"
		chmod a+rw "$dstPath"
	fi

	#echo "Create $dstPath"

	#Move downloaded file from tmp location to final folder
	mv "$_tempDownloadPath/$tmpDstFileNoPath" "$_contentRepoPath/$dstFile"
	#if [ $foundInTemp -ne 0 ]; then
	#	echo $_tempDownloadPath/$localDownloadPath/$fileNoTimeStamp $_contenRepoPath/$dstFile
	#	mv "$_tempDownloadPath/$localDownloadPath/$fileNoTimeStamp" "$_contentRepoPath/$dstFile"
	#else
	#	echo $_tempDownloadPath/$localDownloadPath/$tmpDstFileNoPath $_contentRepoPath/$dstFile
	#	mv "$_tempDownloadPath/$localDownloadPath/$tmpDstFileNoPath" "$_contentRepoPath/$dstFile"
	#fi
	
	if [ $? -ne 0 ]
	then
		Log "Error downloading file: Could not move from temp to final destination"
		let _filesDownloadedFailed=$_filesDownloadedFailed+1
		SendDownloadStatus "$currentindex" "Failed" "$dstFileName"
		return;
	fi

	SendDownloadStatus "$currentindex" "Completed" "$dstFileName"
	
	let _filesDownloadedSuccessfully=$_filesDownloadedSuccessfully+1
}

function DownloadLatestScript() {
	REPLY=""

	#Concat to create complete request
	local request="${_scriptHandlerURL}${_playerID}"
	if [ "$_smarthubURL" = "" ] ; then
		:
	else
		request="$_smarthubURL/smarthubservice/ConfigScriptHandler.ashx?operation=script&id=$_playerID"
	fi
	local dt=$(date +%m-%d-%y-%T)
	
	Log "Downloading Script: ${request}"

	#Download ScriptFile for Player
	#local script=$(wget -qO- "$request")
	local script=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=script&id=$_playerID")
	#echo $script

	#Check if a script was returned
	if [ -z "${script}" ] ; then		
		Log "Failed to download script from server"
	else
		echo "Validating Downloaded Script"
		#PErform a number of checks to confirm script is valid
		if [[ "${script}" = *"<Application xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">"* ]] ; then
			if [[ "${script}" = *"Player.ID="* ]] ; then
				Log "Script Downloaded: Contains all valid definitions"
				REPLY=$script							
			else
				Log "Script from server does not contain \"Player.ID=...\" definition"
				echo "$script" >> "$_logPath/invalidscript_$dt.txt"
			fi
		elif [[ "${script}" = *"<Application xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"* ]] ; then
			#TODO : This is redundant. will be re factored
			if [[ "${script}" = *"Player.ID="* ]] ; then
				Log "Script Downloaded: Contains all valid definitions"
				REPLY=$script							
			else
				Log "Script from server does not contain \"Player.ID=...\" definition"
				echo "$script" >> "$_logPath/invalidscript_$dt.txt"
			fi
		else
			Log "Script from server does not contain \"<Application xmlns:xsi=...\" definition"
			echo "$script" >> "$_logPath/invalidscript_$dt.txt"
		fi	
	fi
}

function ToLower() {
	echo $1 | tr "[:upper:]" "[:lower:]"
}

function RetrieveFilesFromFolder() {
	local path=$1
	declare -a fileListing
	local sub="./"
	local repl=""
	local index=0
	
	#Move to path to search files
	pushd "$path" > /dev/null

	local OLDIFS=$IFS
	IFS=$'\n'
	#find all files in folder and assign to fileListing Array	
	for f in $(find . -type f -name "*.*" -print)
	do
		#Remove the ./ which starts with every file
		local fi=${f/$sub/$repl}		
		#fi=`ToLower "$fi"`						
		#echo "Local $f"
		fileListing[$index]="$fi"
		echo -n "."		
		index=$(($index+1))		
	done
	echo ""
	
	IFS=$OLDIFS

	#Return to original path
	popd > /dev/null

	REPLY=("${fileListing[@]}")	
}

function RetrieveSoftwareUpdatesScript() {
	REPLY=""
	#echo "Creating File Listing..."
	declare -a fileListing
	local scriptFile=$1
	local checksoftwareupdate=false
	local softwarepackagestart=0
	local softwarepackageend=0
	local replycount=0
	local tempfile="$_baseApplicationPath/tempdmscript"
	cp -f "$scriptFile" "$tempfile"
	#tr "[:upper:]" "[:lower:]" < "$scriptFile" > "$tempfile"
	local countersoftwareupdate=0
	
	while read -r line
	do
		
		if "$checksoftwareupdate" ; then
			
			if [ $countersoftwareupdate -eq 0 ] ; then
				OLDIFS=$IFS
				unset SUTEMPARR
				IFS=',' read -ra SUTEMPARR <<< "$line"
				IFS=$OLDIFS
				for header in "${SUTEMPARR[@]}"
				do
					OLDIFS=$IFS
					unset SUTEMPARR2
					IFS='=' read -ra SUTEMPARR2 <<< "$header"
					IFS=$OLDIFS
					if [[ "${SUTEMPARR2[0]}" = "softwarepackages" ]] ; then
						softwarepackagestart="${SUTEMPARR2[1]}"
					elif [[ "${SUTEMPARR2[0]}" = "packagefiles" ]] ; then
						softwarepackageend="${SUTEMPARR2[1]}"
					fi
				done
			fi
			
			#this is software packages table
			if [ $countersoftwareupdate -gt $softwarepackagestart -a $countersoftwareupdate -lt $softwarepackageend ] ; then
				OLDIFS=$IFS
				unset SUTEMPARR
				IFS=',' read -ra SUTEMPARR <<< "$line"
				IFS=$OLDIFS
				colcount=0
				suType=""
				suVersion=""
				suId=""
				for rowval in "${SUTEMPARR[@]}"
				do
					#id
					if [ $colcount -eq 0 ] ; then
						suId=$rowval
					#name
					elif [ $colcount -eq 1 ] ; then
					:
					#type
					elif [ $colcount -eq 2 ] ; then
						suType="$rowval"
					#size
					elif [ $colcount -eq 3 ] ; then
					:
					#createddate
					elif [ $colcount -eq 4 ] ; then
					:
					#updateddate
					elif [ $colcount -eq 5 ] ; then
					:
					#version
					elif [ $colcount -eq 6 ] ; then
						suVersion="$rowval"
					fi
					
					colcount=$((colcount+1))
				done
				if [[ "$suType" = "Edge"* ]] ; then				
					_softwarePackagesInfo[$replycount]="$suId,$suType,$suVersion"				
					replycount=$(($replycount+1))
				fi
				
			fi			
			countersoftwareupdate=$(($countersoftwareupdate+1))
		fi
		
		case "$line" in
			*"<ID>SoftwarePackage_"*)
				checksoftwareupdate=true
			;;	
			*"</FOLDER LISTINGS>"*) 
				checksoftwareupdate=false
			;;
			*)				
			;;
		esac
	done < "$tempfile"
	echo ""
	rm -rf "$tempfile"
}

function RetrieveFilesFromScript() {
	REPLY=""
	#echo "Creating File Listing..."
	declare -a fileListing
	local newparse="$2"
	local doread=false
	local filedone=false
	local currentfile=""
	local count=0
	local scriptFile=$1
	local currenpath=""
	local doproperty=false
	local checksoftwareupdate=false
	local softwarepackagestart=0
	local softwarepackageend=0
	local replycount=0
	local tempfile="$_baseApplicationPath/tempdmscript"
	local countersoftwareupdate=0
	local dosmarthub=false
	local startdatasource=false
	local datasourcestring=""
	local datasourceid=""
	local startelement=false
	local elementid=""
	local elementstring=""
	local counterFile=0
	
	cp -f "$scriptFile" "$tempfile"
	
	if [ "$newparse" = "new" ] ; then
		_downloadmaxspeed=""
		rm -f "$_dataSourcePath/temp_*"
		rm -f "$_elementPath/temp_*"
		_memoryLimit=1500000
	fi
	local lastcheck=`date +%s`
	local smarthubHeaderCount=0
	while read -r line
	do
		if [ $dosmarthub = true ] ; then
			if [[ "$line" = *"SmartHub="* ]] ; then
				continue
			elif [[ "$line" = *"_id,name"* ]] ; then
				smarthubHeaderCount=$(($smarthubHeaderCount+1))
				continue
			elif [[ "$line"] = *"</TABLE>"* ]] ; then
				:
			elif [[ $smarthubHeaderCount -eq 1 ]] ; then				
				_smarthubList["${#_smarthubList[@]}"]="$line"				
			elif [[ $smarthubHeaderCount -eq 2 ]] ; then				
				_cdnList["${#_cdnList[@]}"]="$line"
			fi
		fi
		
		case "$line" in
			*"<ID>ContentDistribution_"*)
				if [ "$newparse" = "new" ] ; then
					dosmarthub=true
				fi
			;;
			*"</TABLE>"*)				
				dosmarthub=false
			;;
			*"<ID>SoftwarePackage_"*)
				checksoftwareupdate=true
			;;
			*"<ID>ApplicationProperties_"*)
				doproperty=true
				
			;;
			*"<FOLDER LISTINGS>"*) 
				doread=true
			;;
			*"</FOLDER LISTINGS>"*) 
				doread=false
				checksoftwareupdate=false
			;;
			*"<PATH>"*)
				if "$doread" ; then
					local temp=${line/<\/PATH>/}
					temp=${temp/<PATH>/}					
					currenpath=$temp
				fi
			;;
			*"<FILE>"*)
				filedone=false
				currentfile=""
			;;
			*"<NAME>"*)
				if "$doread" ; then
					if "$filedone" ; then
						:
					else
						#echo extract file name
						local temp=${line/<\/NAME>/}
						temp=${temp/<NAME>/}
						if [[ "$temp" = "_thumbnail"* ]] || [[ "$temp" = "_vidThumbnail"* ]] ; then
							:
						else
							currentfile="$currenpath\\$temp"
							currentfile=${currentfile/'C:\FastNetV2\'/}
							currentfile=${currentfile/'c:\fastnetv2\'/}
							currentfile=${currentfile/'UG Media'/'ugmedia'}
							currentfile=${currentfile/'ug media'/'ugmedia'}
							
							currentfile=${currentfile//\\/\/}						
							local lcString="$currentfile"
							
							if [[ "${fileListing[@]}" = *"$lcString"* ]] ; then
								:
							else
								fileListing[$count]=$lcString
								#echo "Script $lcString"
								count=$(($count+1))
							fi
						fi
						
						filedone=true
						echo -n "."
					fi
				fi			
			;;
			*"</FOLDER>"*)				
				filedone=false
			;;
			*)				
			;;
		esac
	done < "$tempfile"
	echo ""
	REPLY=("${fileListing[@]}")	
	rm -rf "$tempfile"

	#echo "${REPLY[@]}"
	#echo "Creating File Listing...[DONE]"
}

function AreFilesTheSame() {
	local fileA="$1"
	local fileB="$2"
		
	if [[ "$fileA" == "$fileB" ]]
	then
		REPLY="true"
		#echo "$fileA is same as $fileB"
		return
	else
		#echo "$fileA is not same as $fileB"
		REPLY="false"
		return
	fi
	REPLY="false"	
}

function RetrieveMissingFiles() {
	
	declare -a fullCollection
	fullCollection=("${!1}")
	declare -a partialCollection
	partialCollection=("${!2}")

	declare -a missingCollection
	local missingIndex=0

	local OLDIFS=$IFS
	IFS=$'\n'
	
	strtocheck=`echo "${partialCollection[@]}" | tr '[:upper:]' '[:lower:]'`
	
	#Iterate through the full collection
	for i in "${fullCollection[@]}"
	do		
		local compare=`echo "$i" | tr '[:upper:]' '[:lower:]'`
		if [[ "$strtocheck" = *"$compare"* ]]
		then
			echo -n "."
			#echo "Found file: $i"
		else
			#echo "File not found $i"
			missingCollection[$missingIndex]="$i"
			#missingCollection["SS"]="$i"
			missingIndex=$(($missingIndex+1))
		fi
	done

	IFS=$OLDIFS

	echo ""

	REPLY=("${missingCollection[@]}")		

	return
}

function ResolveFileLocation() {
	local fileLocalPath=$1
	#convert all backslashes to forward slashes
	local fileRemotePath=${fileLocalPath//\\/\/}
	fileRemotePath=${fileRemotePath//ugmedia\//UG%20Media\/}	
	if [ "$_contentURL" = "" ] ; then
		fileRemotePath="$_appSpaceURL$_mediaHandlerURL$fileRemotePath"
	else
		fileRemotePath="$_contentURL$_mediaHandlerURL$fileRemotePath"
	fi
	#echo "$fileRemotePath"
	REPLY="$fileRemotePath"	
	return
}

function DownloadMissingFiles() {
	declare -a downloadFiles
	downloadFiles=("${!1}")

	_filesDownloadedSuccessfully=0
	_filesDownloadedFailed=0

	local count=1	
	local total="${#downloadFiles[@]}"

	SendDownloadInitStatus "$total"
	
	#Iterate through missing files
	for i in "${downloadFiles[@]}"
	do	
		ResolveFileLocation "$i"
		local remoteFile="$REPLY"
		i=`echo "$i" | tr '[:upper:]' '[:lower:]'`
		#echo "Missing file $remoteFile"
		DownloadFile "$remoteFile" "$i" "$count" "$total"
		count=$(($count+1))
		#echo "$_filesDownloadedSuccessfully of ${#downloadFiles[@]} downloaded successfully ($_filesDownloadedFailed failed)"
	done
	Log "$_filesDownloadedSuccessfully of ${#downloadFiles[@]} downloaded successfully ($_filesDownloadedFailed failed)"
	return
}

function DeleteFiles() {
	declare -a filesToDelete
	filesToDelete=("${!1}")

	local filesDeletedSuccessfully=0
	local filesDeletedFailed=0

	#Iterate through missing files
	for i in "${filesToDelete[@]}"
	do	
		GetFilePath "$_contentRepoPath/$i"
		local path=$REPLY
		#echo "$path"
		Log "Deleting $_contentRepoPath/$i"
		rm -rf "$_contentRepoPath/$i"
		local dirpath=$(dirname "$_contentRepoPath/$i")
		if [ "$(ls -A $dirpath)" ]; then
			Log "$dirpath is not empty"
		else
			Log "$dirpath is empty, deleting folder"
			rm -rf $dirpath
		fi
		filesDeletedSuccessfully=$(($filesDeletedSuccessfully+1))		
	done

	#Move to path to search files
	pushd "$_contentRepoPath" > /dev/null

	local OLDIFS=$IFS
	IFS=$'\n'

	#find all empty folders and delete
	#for f in $(find . -type d -empty)
	#do
	#	#Delete empty 
	#	rm -r "$f"
	#	#echo "Empty $f"		
	#done

	IFS=$OLDIFS


	#Return to original path
	popd > /dev/null

	Log "$filesDeletedSuccessfully of ${#filesToDelete[@]} deleted successfully"
	return
}

function DoSoftwareUpdate()
{
	Log "Processing Software Updates ( ${#_softwarePackagesInfo[@]} updates )"
	local tempPath="$_baseApplicationPath/Temp Downloads/"
	local doSoftwareUpdateCount=0
	local versionPath="$_baseApplicationPath/version.inf"
	# from script
	if [[ ${#_softwarePackagesInfo[@]} -gt 0 ]] ; then
		spId=""
		spType=""
		spVersion=""
			
		if [[ ! -e $versionPath ]] ; then
			touch $versionPath
		fi
		
		#get version from file
		while read line
		do
			versionFromFile="$line"
		done < "$versionPath"
		
		# array format = softwarepackageid,type,version
		local versiontosubmit=""
		for package in "${_softwarePackagesInfo[@]}"
		do
			unset TEMPARR
			OLDIFS=$IFS
			IFS="," read -ra TEMPARR <<< "$package"
			IFS=$OLDIFS
			spId="${TEMPARR[0]}"
			spType="${TEMPARR[1]}"
			spVersion="${TEMPARR[2]}"
			executed="false"	
			if [ "$spId" != "" -a "$spType" != "" -a "$spVersion" != "" ] ; then
				#check if this script already executed
				
				local currentVersion=`echo "$versionFromFile" | sed 's/Edge Player=//g'`
				currentVersion=`echo "$currentVersion" | sed 's/edge player=//g'`
				
				local updatepackagetype=`echo "$spType" | tr '[:upper:]' '[:lower:]'`
				
				if [ "$updatepackagetype" = "edge player" ]; then
					if [ "$spVersion" = "$currentVersion" ]; then
						executed="true"
					fi
				fi
				
				versiontosubmit="$spVersion"
				
				if [[ "$executed" = "false" ]] ; then
					Log "Applying Software Update ($spVersion)"
					local spPath="$_baseApplicationPath/contentrepo/softwarepackages/$spId/"
					local tempPath="$_baseApplicationPath/Temp Downloads/$spId/"
					
					if [[ ! -d "$tempPath" ]] ; then
						mkdir "$tempPath"	
					fi
					
					RetrieveFilesFromFolder "$spPath"
					declare -a spFiles
					spFiles=("${REPLY[@]}")
					
					local spFolderCounter=0
					for spFile in "${spFiles[@]}"
					do
						if [[ "$spFile" = *".tar" ]] ; then
							mkdir "$tempPath""$spFolderCounter"
							tar xvf "$spPath""$spFile" -C "$tempPath""$spFolderCounter" > /dev/null
							if [[ -e "$tempPath""$spFolderCounter/setup.sh" ]] ; then
								pushd "$tempPath""$spFolderCounter" > /dev/null
								
								if [ "$_deviceType" = "edge340" ] ; then
									if [ -f "$tempPath""$spFolderCounter/setup.340.sh" ] ; then
										dos2unix "$tempPath""$spFolderCounter/setup.340.sh"
										/bin/bash "$tempPath""$spFolderCounter/setup.340.sh" > /dev/null
									fi
								else
									if [ -f "$tempPath""$spFolderCounter/setup.300.sh" ] ; then
										dos2unix "$tempPath""$spFolderCounter/setup.300.sh"
										/bin/bash "$tempPath""$spFolderCounter/setup.300.sh" > /dev/null
									elif [ -f "$tempPath""$spFolderCounter/setup.sh" ] ; then
										dos2unix "$tempPath""$spFolderCounter/setup.sh"
										/bin/bash "$tempPath""$spFolderCounter/setup.sh" -workingfolder "$_baseApplicationPath" > /dev/null
									fi
								fi
								popd > /dev/null
								doSoftwareUpdateCount=$(($doSoftwareUpdateCount+1))
							fi
							spFolderCounter=$(($spFolderCounter+1))
						fi
					done
					
					rm -rf "$tempPath"
				else
					Log "Software update has already been applied"
				fi				
			fi
		done
		
		if [[ $doSoftwareUpdateCount -gt 0 ]] ; then
			if [[ ! "$_playerID" = "" ]] ; then
				_addPropertyHandlerURL="$_appSpaceURL/integrationwebservices/configscripthandler.ashx?operation=setproperty&key=Player.Software.Version&value=$versiontosubmit&type=player&id=$_playerID"
				Log "Send version info : $_addPropertyHandlerURL"
				#local ts2=$(wget -qO- "$_addPropertyHandlerURL")
				local ts2=$(curl -fsLk --connect-timeout 30 --url "$_appSpaceURL/integrationwebservices/configscripthandler.ashx" -d "operation=setproperty&key=Player.Software.Version&value=$versiontosubmit&type=player&id=$_playerID")
				if [[ -z "${ts2}" ]] ; then		
					Log "Failed to send version info"
				else
					Log "Version info sent"
				fi
				echo "Edge Player=$versiontosubmit" > "$versionPath"
			fi			
		fi
		unset _softwarePackagesInfo
		
	fi
	
	Log "Software Update completed ($doSoftwareUpdateCount update(s) completed)"
}

function MergeArray(){
	declare -a array1
	declare -a array2
	declare -a resultArray
	
	array1=("${!1}")
	array2=("${!2}")
	
	#if [[ "${fileListing[@]}" = *"$lcString"* ]] ; then
	
	local count=0
	
	resultArray=("${array1[@]}")
	count=${#resultArray[@]}
	count=$(($count-1))
	
	if [[ $count -eq -1 ]] ; then
		count=0
	fi
	
	for arr2 in "${array2[@]}"
	do
		if [[ "${resultArray[@]}" = *"$arr2"* ]] ; then
			:
		else
			count=$(($count+1))
			resultArray[$count]="$arr2"
		fi		
	done
	
	REPLY=("${resultArray[@]}")	
}

function RetrievePlayerPropertyFromFile(){
	Log "Retrieving $1 from $2"
	local file="$2"
	local property="$1="
	REPLY=""
	if [ -f $file ] ; then
		local data=`cat $file | grep -i $property`
		if [ "$data" != "" ] ; then
			echo "$data" > $_tempPath/process.data
			dos2unix $_tempPath/process.data
			data=`cat $_tempPath/process.data`
			rm -f $_tempPath/process.data
			data=`echo "$data" | sed "s/$property//g"`
			data=`echo "$data" | sed "s/;//g"`
			REPLY="$data"
		fi
	fi
}

function CheckCDNStatus(){
	local cdnurl="$1"
	local cdntype="$2"
	local cdnpingfile="$3"
	
	Log "Check $cdnurl ($cdntype) status"
	
	local checkurl=""
	local checkres=""
	_CDNREPLY=""
	if [ "$cdntype" = "smarthub" ] ; then
		checkurl="$cdnurl/smarthubservice/ConfigScriptHandler.ashx?operation=smarthub&id=$_playerID"
		Log "Requesting $checkurl"
		checkres=$(curl -fsLk --connect-timeout 30 --url "$checkurl")
		if [ "$checkres" = "ready" ] ; then
			_CDNREPLY="true"
		else
			_CDNREPLY="false"
		fi
	elif [ "$cdntype" = "cdn" ] ; then
		checkurl="$cdnurl/$cdnpingfile"
		Log "Requesting $checkurl"
		#f : don't show error ; s : silent ; L : redirect if needed ; k : allow insecure https ; I : header only
		checkres=$(curl -sLkI --connect-timeout 30 --url "$checkurl")		
		#retrieve line with http/ : grep -i http/
		#remove HTTP/1.1 and HTTP/1.0* : sed 's/[Hh][Tt][Tt][Pp]\/1.1 //g' | sed 's/[Hh][Tt][Tt][Pp]\/1.0 //g'
		#exclude redirection code : grep -v "30*"
		local stringtocheck=`echo "$checkres" | grep -i http/ | sed 's/[Hh][Tt][Tt][Pp]\/1.1 //g' | sed 's/[Hh][Tt][Tt][Pp]\/1.0 //g' | grep -v "30*"`
		#if res is empty or starts with 4 or 5 response code, consider fail
		if [[ $stringtocheck = "" || $stringtocheck = 4* || $stringtocheck = 5* ]] ; then
			_CDNREPLY="false"
		else
			_CDNREPLY="true"
		fi
	fi
	Log "Status:$_CDNREPLY"
}

function FindActiveCDNNodes(){
	Log "Find active CDN nodes"
	_smarthubURL=""
	_CDNURL=""
	_contentURL=""
	_ACTIVECDN=""
	_CDNPingFile=""
	local firstsmarthub=""
	Log "Checking ${#_smarthubList[@]} SmartHubs"	
	if [ ${#_smarthubList[@]} = "0" ] ; then
		:
	else
		for smarthubRaw in "${_smarthubList[@]}"
		do
			OLDIFS=$IFS
			unset SUTEMPARR
			IFS=',' read -ra SUTEMPARR <<< "$smarthubRaw"
			IFS=$OLDIFS
			local smarthuburl="${SUTEMPARR[3]}"
			local smarthubport="${SUTEMPARR[4]}"
			if [ "$smarthubport" = "" ] ; then
				:
			else
				smarthuburl="$smarthuburl:$smarthubport"
			fi
			
			if [ "`echo $smarthuburl | grep -i 'http:'`" = "" ] ; then
				if [ "`echo $smarthuburl | grep -i 'https:'`" = "" ] ; then
					smarthuburl="http://$smarthuburl"
				fi
			fi
			
			if [ "$firstsmarthub" = "" ] ; then
				firstsmarthub="$smarthuburl"
			fi
			#check status
			CheckCDNStatus "$smarthuburl" "smarthub"
			if [ "$_CDNREPLY" = "true" ] ; then
				_smarthubURL="$smarthuburl"
				_contentURL="$smarthuburl"
				_ACTIVECDN="$smarthuburl"
				break
			fi
		done
	fi
	
	#if smarthub is empty AND don't ignore smarthub AND there's smarthub in the list
	if [[ "$_smarthubURL" = "" &&  "$_ignoreOfflineSmarthub" = "false" && "$firstsmarthub" != "" ]] ; then
		_smarthubURL="$firstsmarthub"
		_contentURL="$firstsmarthub"
		_ACTIVECDN="$firstsmarthub"
	fi
	
	if [ "$_smarthubURL" = "" ] ; then
		Log "Checking ${#_cdnList[@]} CDNs"
		if [ ${#_cdnList[@]} = "0" ] ; then
			:
		else
			for cdnRaw in "${_cdnList[@]}"
			do
				OLDIFS=$IFS
				unset SUTEMPARR
				IFS=',' read -ra SUTEMPARR <<< "$cdnRaw"
				IFS=$OLDIFS
				local cdnurl="${SUTEMPARR[3]}"
				local pingfile="${SUTEMPARR[4]}"
				
				if [ "`echo $cdnurl | grep -i 'http:'`" = "" ] ; then
					if [ "`echo $cdnurl | grep -i 'https:'`" = "" ] ; then
						cdnurl="http://$cdnurl"
					fi
				fi
				#check status
				CheckCDNStatus "$cdnurl" "cdn" "$pingfile"
				if [ "$_CDNREPLY" = "true" ] ; then
					_CDNURL="$cdnurl"
					_CDNPingFile="$pingfile"
					_contentURL="$cdnurl"
					_ACTIVECDN="$cdnurl"
					break
				fi
			done
		fi
	fi
	
	Log "Find active CDN nodes result:"
	Log "SmartHub URL:$_smarthubURL"
	Log "CDN URL:$_CDNURL"
	Log "Content URL:$_contentURL"
}

function UpdateCDNNode(){
	local checkurl=""
	local checktype=""
	local pingfile=""
	
	if [ "$_smarthubURL" != "" ] ; then
		checkurl="$_smarthubURL"
		checktype="smarthub"
	elif [ "$_CDNURL" != "" ] ; then
		checkurl="$_CDNURL"
		checktype="cdn"
		pingfile="$_CDNPingFile"
	fi
	
	CheckCDNStatus "$checkurl" "$checktype" "$pingfile"
	if [ "$_CDNREPLY" = "false" ] ; then
		Log "Active CDN not online: $checkurl ($checktype)"
		FindActiveCDNNodes
	fi
}

function RetrieveSmarthubListing(){
	REPLY=""
	local argsmarthub="operation=retrievesmarthublisting scriptfile=\"$1\" scriptpath=\"/apps/nexus2\""
	local node="/apps/nexus2/node"
	local nodescript="/apps/nexus2/nodescripts/appspacenodeservices/services/script/main.js"
	declare -a smarthubList
	
	rm -rf /apps/nexus2/nodejsoutput
	$node $nodescript $argsmarthub
	if [ -f /apps/nexus2/nodejsoutput ] ; then
		local count=0
		while read line
		do
			if [ "$line" = "" ] ; then
				continue
			fi
			smarthubList[$count]="$line"
			count=$(($count+1))
		done < /apps/nexus2/nodejsoutput
	fi
	
	REPLY=("${smarthubList[@]}")
}

function RetrieveCDNListing(){
	REPLY=""
	local argsmarthub="operation=retrievecdnlisting scriptfile=\"$1\" scriptpath=\"/apps/nexus2\""
	local node="/apps/nexus2/node"
	local nodescript="/apps/nexus2/nodescripts/appspacenodeservices/services/script/main.js"
	declare -a cdnList
	
	rm -rf /apps/nexus2/nodejsoutput
	$node $nodescript $argsmarthub
	if [ -f /apps/nexus2/nodejsoutput ] ; then
		local count=0
		while read line
		do
			if [ "$line" = "" ] ; then
				continue
			fi
			cdnList[$count]="$line"
			count=$(($count+1))
		done < /apps/nexus2/nodejsoutput
	fi
	
	REPLY=("${cdnList[@]}")
}

function RetrieveFilesToDownload(){
	REPLY=""
	local arg="operation=retrievefilestodownload scriptfile=\"$1\" scriptpath=\"/apps/nexus2\" contentpath=\"/apps/nexus2/contentrepo\""
	local node="/apps/nexus2/node"
	local nodescript="/apps/nexus2/nodescripts/appspacenodeservices/services/script/main.js"
	
	rm -rf /apps/nexus2/nodejsoutput

	declare -a filestodownload

	$node $nodescript $arg

	if [ -f /apps/nexus2/nodejsoutput ] ; then
		local count=0
		while read line
		do
			if [ "$line" = "" ] ; then
				continue
			fi
			filestodownload[$count]=$line
			count=$(($count+1))
		done < /apps/nexus2/nodejsoutput
	fi

	REPLY=("${filestodownload[@]}")
}

function RetrieveFilesToDelete(){
	REPLY=""
	local arg="operation=retrievefilestodelete scriptfile=\"$1\" oldscriptfile=\"$2\" scriptpath=\"/apps/nexus2\" contentpath=\"/apps/nexus2/contentrepo\""
	local node="/apps/nexus2/node"
	local nodescript="/apps/nexus2/nodescripts/appspacenodeservices/services/script/main.js"

	rm -rf /apps/nexus2/nodejsoutput

	declare -a filestodelete

	$node $nodescript $arg

	if [ -f /apps/nexus2/nodejsoutput ] ; then
		local count=0
		while read line
		do
			if [ "$line" = "" ] ; then
				continue
			fi
			
			filestodelete[$count]=$line
			count=$(($count+1))
		done < /apps/nexus2/nodejsoutput
	fi

	REPLY=("${filestodelete[@]}")
}

function SyncLoop() {
	Log "Load client sync configuration"
	#Load configuration settings
	LoadConfiguration
	
	
	if [ "$_contentSyncEnabled" = "true" ] ; then
		:
	else
		return
	fi

	Log "Starting Content Sync: `date`"
	touch $_dmHeartbeatFile
	if [[ -f "$_baseApplicationPath/$_scriptFile" ]] ; then
		GetSyncSchedule	
		if [ "$_REPLY" = "" ]; then
			if [ "$_syncschedule" = "" ] ; then
				Log "No sync schedule available"
			else
				_syncscheduleFailCount=$(($_syncscheduleFailCount+1))
				if [ "$_syncscheduleFailCount" -gt 3 ] ; then
					Log "Failed to retrieve sync schedule after 3 tries. Assuming sync schedule has been removed"
					_syncschedule=""
					_syncscheduleFailCount=0
				else
					Log "Failed to retrieve sync schedule after sync schedule is available($_syncschedule) - Warning #$_syncscheduleFailCount"
					_REPLY="false"
					return
				fi
			fi
		else
			_syncschedule="$_REPLY"	
			_syncscheduleFailCount=0			
			CheckSyncSchedule
			if [ "$_REPLY" = "false" ]; then
				Log "Content syncing not scheduled at this time. $_syncschedule"
				if [ "$_sendInSync" = "true" ] ; then
					Log "In Sync status need to be submit first"
				else
					_REPLY="false"
					return
				fi
			else
				Log "Content sync schedule is valid"
			fi
		fi		
	fi

	if [ "$_ACTIVECDN" != "" ] ; then
		UpdateCDNNode
	fi
	
	_doSoftwareUpdate=false
	
	Log "Current Sync Status: $_inSync"
	declare -a filesInScript
	declare -a missingFiles
	touch $_dmHeartbeatFile
	#Get Latest timestamp
	CheckTimeStamp
	local contentTimeStamp=$REPLY 

	#Load previous timstamp into memory
	local currentContentTimeStamp=""	
	if [[ -f "$_baseApplicationPath/$_timeStampFile" ]] ; then
		currentContentTimeStamp=`cat "$_baseApplicationPath/$_timeStampFile"`
		Log "Local TimeStamp $currentContentTimeStamp"
	else
		Log "No local timestamp available"
	fi
	
	#if [ "$contentTimeStamp" = "" ] ; then
	#	Log "Content timestamp empty, retrying from AppSpace server"
	#	_smarthubURL=""
	#	CheckTimeStamp
	#	contentTimeStamp=$REPLY
	#fi
	touch $_dmHeartbeatFile
	
	if [ "$contentTimeStamp" = "" ] ; then
		Log "Content timestamp empty, retrying on next sync loop cycle"
		return
	fi
	
	#Load previous script into memory
	local playerScript=""
	if [[ -f "$_baseApplicationPath/$_scriptTempFile" ]] ; then
		#dos2unix "$_baseApplicationPath/$_scriptTempFile" > /dev/null
		playerScript=`cat "$_baseApplicationPath/$_scriptTempFile"`
	else
		Log "No previous script available"
	fi
	
	#Check if the current timestamp we have is same as AppSpace
	if [ "$contentTimeStamp" != "$currentContentTimeStamp" -o ${#playerScript} -lt 1 ]
	then	
		_inSync="false"
		touch $_dmHeartbeatFile
		#Downloaded Latest Script from Appspace
		DownloadLatestScript
		playerScript=$REPLY 
		#echo "$playerScript"
	else
		Log "Timestamp matches server, using cached script file"
		_lastContentTimestamp="$contentTimeStamp"
	fi

	#Check did we download the script file from the server
	if [ ${#playerScript} -lt 1 ]
	then
		Log "Problem downloading player script, length is less than zero"
		_inSync="false"
		return
	fi

	if [ "$_inSync" = "true" ]
	then
		Log "Scripts already in sync. Skipping file repository check"
		if [ "$_sendInSync" = "true" ]		
		then
			pushd $_tempDownloadPath > /dev/null
			rm -rf "$_tempDownloadPath/*"
			popd > /dev/null
			#Send InSync Status to AppSpace
			SendInSync "$contentTimeStamp"
			SendDownloadInitStatus "0"
			if [ "$REPLY" = "true" ] ; then
				_sendInSync="false"
			else
				_sendInSync="true"
			fi
		fi
		
		#DoSoftwareUpdate
		
		return
	else
		Log "Scripts not in sync. Status is $_inSync"
		_sendInSync="false"
	fi
	
	#Delete Previous
	rm "$_baseApplicationPath/$_scriptTempFile"	
	#Save script to temporary file
	echo "$playerScript" > "$_baseApplicationPath/$_scriptTempFile"
	
	touch $_dmHeartbeatFile
	
	
	#Retrieve properties
	Log "Retrieving player properties"
	local temp=""
	RetrievePlayerPropertyFromFile "Player.ExternalStorage" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"		
	if [ "$temp" != "" ] ; then
		if [ "$temp" != "$_previousExternalStorage" ] ; then
			local esoutput=""
			local targetline=""
			local checkexternalstorage=""
			if [ "$temp" = "true" ] ; then
				Log "Mounting external storage"
				targetline="externalstorage=true"
				esoutput=`/bin/bash /apps/nexus2/storagecontroller.sh mount`
			elif [ "$temp" = "false" ] ; then
				Log "Unmounting external storage"
				targetline="externalstorage=false"
				esoutput=`/bin/bash /apps/nexus2/storagecontroller.sh unmount`
			fi
			Log "$esoutput"
			
			local tempnodedat=`cat /apps/nexus2/node.dat`
			checkexternalstorage=$(echo $tempnodedat | grep -i externalstorage);
			if [ "$checkexternalstorage" = "" ] ; then
				echo $targetline >> /apps/nexus2/node.dat
			else
				touch /apps/nexus2/tempnode.dat
				while read linenodedat
				do
					if [ "$(echo $linenodedat | grep -i externalstorage)" != "" ] ; then
						echo $targetline >> /apps/nexus2/tempnode.dat
					else
						echo $linenodedat >> /apps/nexus2/tempnode.dat
					fi
				done < /apps/nexus2/node.dat
				mv -f /apps/nexus2/tempnode.dat /apps/nexus2/node.dat
			fi
			Log "Restart download manager as storage location has been changed"
			_previousExternalStorage="$temp"
			exit
		fi
	fi
	
	_memoryLimit=1500000
	
	RetrievePlayerPropertyFromFile "Player.Edge300.Chrome.Memory.Limit" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp"  = "" ]; then
		:
	elif [ `echo "$temp" | grep "^[0-9]*$"` ]; then					
		_memoryLimit=$temp		
	fi
	
	RetrievePlayerPropertyFromFile "Player.Edge.Chrome.Memory.Limit" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp"  = "" ]; then
		:
	elif [ `echo "$temp" | grep "^[0-9]*$"` ]; then					
		_memoryLimit=$temp		
	fi
	
	RetrievePlayerPropertyFromFile "Player.Edge.ResumeDownloads" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp"  = "" ]; then
		_useResumeDownload="false"
	else
		_useResumeDownload=$temp
	fi
	RetrievePlayerPropertyFromFile "CDNAgent.ContentDownloadMaxSpeed" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp"  = "" ]; then
		_downloadmaxspeed=""
	elif [ `echo "$temp" | grep "^[0-9]*$"` ]; then					
		_downloadmaxspeed=$(( $temp / 1000 ))
		_downloadmaxspeed="$_downloadmaxspeed""K"				
	fi
	RetrievePlayerPropertyFromFile "CDNAgent.ContentDownloadCycle" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp"  = "" ]; then
		_syncInterval=30
	elif [ `echo "$temp" | grep "^[0-9]*$"` ]; then					
		_syncInterval=$(( $temp / 1000 ))		
	fi
	
	RetrievePlayerPropertyFromFile "Player.Sync.Notifications.Enable" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp" = "" ] ; then
		_syncNotificationEnable="true"
	elif [ "$temp" = "true" ] ; then
		_syncNotificationEnable="true"
	else
		_syncNotificationEnable="false"
	fi
	
	RetrievePlayerPropertyFromFile "System.RebootEvents" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	if [ "$temp" = "" ] ; then
		_rebootEvent="0"
	else
		_rebootEvent="$temp"
	fi
	
	RetrievePlayerPropertyFromFile "Downloadmanager.Smarthub.IgnoreWhenOffline" "$_baseApplicationPath/$_scriptTempFile"
	temp="$REPLY"
	temp=`echo $temp | tr "[:upper:]" "[:lower:]"`
	if [ "$temp" = "" ] ; then
		_ignoreOfflineSmarthub="true"
	else
		_ignoreOfflineSmarthub="$temp"
	fi
	
	#Retrieve smarthub listing
	Log "Retrieving SmartHub listing..."
	unset _smarthubList
	declare -a _smarthubList
	RetrieveSmarthubListing "$_scriptTempFile"
	_smarthubList=("${REPLY[@]}")
	Log "Retrieved ${#_smarthubList[@]} SmartHubs"
	
	#Retrieve cdn listing
	Log "Retrieving CDN listing..."
	unset _cdnList
	declare -a _cdnList
	RetrieveCDNListing "$_scriptTempFile"
	_cdnList=("${REPLY[@]}")
	Log "Retrieved ${#_cdnList[@]} CDNs"
	
	#Retrieve files to download
	Log "Retrieving files to download..."
	unset filesToDownload
	declare -a filesToDownload
	RetrieveFilesToDownload "$_scriptTempFile"
	filesToDownload=("${REPLY[@]}")
	Log "Retrieved ${#filesToDownload[@]} files"
	
	#Retrieve files to delete
	Log "Retrieving files to delete..."
	unset myfilesToDelete
	declare -a myfilesToDelete
	RetrieveFilesToDelete "$_scriptTempFile" "$_scriptFile"
	myfilesToDelete=("${REPLY[@]}")
	Log "Retrieved ${#myfilesToDelete[@]} files"
	
	#check smarthub and CDN
	local prevSmarthub="$_smarthubURL"
	FindActiveCDNNodes
	if [ "$_ACTIVECDN" != "" ] ; then
		if [[ "$_smarthubURL" != "" && "$_smarthubURL" != "$prevSmarthub" ]] ; then
			Log "Switched to SmartHub ($_smarthubURL), restarting sync loop"
			return
		fi
	fi
	
	#delete files
	if [ ${#myfilesToDelete[@]} -ne 0 ] ; then
		Log "Deleting ${#myfilesToDelete[@]} file(s)..."
		DeleteFiles myfilesToDelete[@]
	fi
	
	#download files
	touch $_dmHeartbeatFile
	SendDownloadInitStatus "0"
	Log "Downloading ${#filesToDownload[@]} missing files...(this may take a few minutes)"	
	DownloadMissingFiles filesToDownload[@]
	if [ $_filesDownloadedFailed -ne 0 ]
	then
		Log "Not all files were downloaded succesfully: $_filesDownloadedFailed failed, retrying...."
		return
	fi
	Log "Download completed"
	
	#update script
	touch $_dmHeartbeatFile
	Log "Updating script"
	echo "$playerScript" > "$_baseApplicationPath/$_scriptFile"
	
	#update timestamp
	Log "Updating timestamp"
	echo "$contentTimeStamp" > "$_baseApplicationPath/$_timeStampFile"
	
	Log "All files have been downloaded and local repository is in sync"
	_lastContentTimestamp="$contentTimeStamp"
	_sendInSync="true"
	_inSync="true"
	_REPLY=""
	
	Log "Checking client startup URL"
	local startupurl=`cat "$_baseApplicationPath/$_scriptFile" | grep -i "Client.StartupURL"`
	if [ "$startupurl" = "" ] ; then
		[ -f /apps/nexus2/startupurl ] && rm -f /apps/nexus2/startupurl
	else
		startupurl=`echo $startupurl | sed 's/Client.StartupURL=//g'`
		startupurl="file:///apps/nexus2/contentrepo/$startupurl"
		startupurl=`echo $startupurl | tr "[:upper:]" "[:lower:]"`
		local doreplace="true"
		if [ -f /apps/nexus2/startupurl ] ; then
			local checkstartup=`cat /apps/nexus2/startupurl`
			if [ "$checkstartup" = "$startupurl" ] ; then
				doreplace="false"
			fi
		fi
		
		if [ "$doreplace" = "true" ] ; then			
			Log "Replacing client startup URL : $startupurl"
			echo "$startupurl" > /apps/nexus2/startupurl
			killall -2 chrome
		fi
	fi
}

function RunWatchdog() {
	
	if [ "$_watchdogEnabled" = "true" ] ; then
		:
	else
		return
	fi
	
	local check="player-holder.html"
	[[ -f /apps/nexus2/startupurl ]] && check=`cat /apps/nexus2/startupurl`
	if [ -f /apps/nexus2/desktop-enable ] ; then
		Log "Skipping watchdog. Desktop is enabled"
		return
	elif [[ "$check" != *"player-holder.html"* ]] ; then
		Log "Skipping watchdog. Chrome is running $check"
		return
	fi
	
	
	echo "Starting Watchdog"
	if [ -f $_heartbeatFile ]
	then
		echo "Heartbeat file: $_heartbeatFile exists"
	else
		Log "Heartbeat file: $_heartbeatFile does not exist!"
		echo "No previous heartbeat so skipping check"
		return
	fi
	
	local currentFileTime=`date -r $_heartbeatFile +%M`
	#Remove leading zeros
	currentFileTime="$(echo $currentFileTime | sed 's/0*//')"
	
	local currentTime=`date +%M`
	#Remove leading zeros
	currentTime="$(echo $currentTime | sed 's/0*//')"
	
	echo "Heartbeat is $currentFileTime / Time is $currentTime"

	#Check if the hour has wrapped
	if [ $currentTime -lt $currentFileTime ]
	then
		#echo "Skipping this as current hearbeart has wrapped round the hour"
		echo "Current time has wrapped around the hour, setting hearbeart to 0min"
		currentFileTime=0
		#return
	fi
	
		
	
	#Calculate the number of minutes since last heartbeat
	local difference=$((currentTime-currentFileTime))
		
	#If less than 3 mins we ignore
	if [ $difference -lt 3 ]
	then
		_heartbeatTimeoutCount=1
	fi
	
	#Determine max diffrence based on number of times we have updated
	local maxDifference=$((3*_heartbeatTimeoutCount))
	#echo "Last hearbeat difference in minutes is $difference - max allowed is $maxDifference minutes"
	Log "Last hearbeat difference in minutes is $difference - max allowed is $maxDifference minutes"
	if [ $difference -gt $maxDifference ]
	then
		#update the number of times we tried to reload flash
		_heartbeatTimeoutCount=$((_heartbeatTimeoutCount+1))
		Log "Heartbeat difference is more than allowed. Warning no. $_heartbeatTimeoutCount"
		if [ $_heartbeatTimeoutCount -gt 2 ]
		then
			Log "Restarting chrome as flash has failed to load after $difference minutes"
			KillChrome
		fi
	fi	
}

function CheckForSofwareUpdates() {

	echo "Starting Software Updates Check: Last check at $_lastSoftwareUpdateTimestamp"
	
	
	if [ "$_lastContentTimestamp" = "" ]
	then
		Log "Skipping software updates check as last content timestamp is empty"
		return
	fi
	
	#Check if we have content sync disabled we need to get the timestamp from file
	if [ $_contentSyncEnabled = "false" ]
	then				
		_lastContentTimestamp=`cat "$_baseApplicationPath/$_timeStampFile"`
	fi
	
	if [ "$_lastContentTimestamp" = "$_lastSoftwareUpdateTimestamp" ]
	then
		echo "No change in timestamp, skipping software updates"
		return
	fi
		
	#Check if we have content sync enabled, if not we may need to manually parse script for update packages
	#if [ "$_contentSyncEnabled" = "false" ]
	#then
	Log "Retrieving software update information from script. This may take a few minutes..."
	RetrieveSoftwareUpdatesScript "$_baseApplicationPath/$_scriptFile"		
	#fi
	
	Log "Performing sofware update. This may take a few minutes..."
	DoSoftwareUpdate
	_lastSoftwareUpdateTimestamp="$_lastContentTimestamp"
	Log "Finshed software updates checking: $_lastSoftwareUpdateTimestamp"
}

function MemoryWatch() {
	if [ "$_memoryWatchEnabled" = "true" ] ; then
		:
	else
		_chromeMemoryTotal=0
		_chromeMemoryCount=0
		return
	fi
	
	#_memoryLimit
	processes=`ps -C chrome -o rss=`
	if [ "$processes" != "" ]; then
		total=0
		for i in $processes
		do
				total=$(($total+$i))
		done
		if [[ $total -gt $_memoryLimit ]] ; then			
			echo "no splash needed" >> "$_baseApplicationPath/nosplash.txt"
			Log "Restart chrome as chrome memory usage is greater than $_memoryLimit. Current memory usage : $total"
			KillChrome
			Log "Delete previous heartbeat file"
			rm -rf "$_heartbeatFile"
			touch "$_heartbeatFile"
			_chromeMemoryTotal=0
			_chromeMemoryCount=0
		else
			_chromeMemoryTotal=$(($_chromeMemoryTotal+$total))
			_chromeMemoryCount=$(($_chromeMemoryCount+1))
			local average=$(($_chromeMemoryTotal/$_chromeMemoryCount))
			Log "Current chrome memory : $total. Maximum limit : $_memoryLimit. Average : $average"
		fi
	fi

}

function DumpDeviceInfo(){
	local maxtry=50
	local curtry=1
	local ip=""
	while true
	do
		GetIPAddress
		ip="$REPLY"
		if [ "$ip" = "" ] ; then
			:
		else
			break
		fi
		curtry=$(($curtry+1)) 
		if [ $curtry -ge $maxtry ] ; then
			break
		fi
		sleep 5
	done
	
	GetMACAddress
	local mac="$REPLY"
	GetDeviceFirmware
	local devicefirmware="$REPLY"
	
	Log "Dumping Device info to $_baseApplicationPath/device.info ($curtry out of $maxtry tries)"
	Log "Device Info:localip=$ip;mac=$mac;devicefirmware=$devicefirmware"
	echo "localip=$ip;mac=$mac;devicefirmware=$devicefirmware" > "$_baseApplicationPath/device.info"
}

function CheckSystemReboot(){
	Log "System Reboot Event : $_rebootEvent"
	local tmpRebootFile="/apps/nexus2/Logs/lastDeviceReboot.txt"
	local lastReboot=`date +"%F %T"`
	local currentTime=`date +"%F %T"`
	if [ -f $tmpRebootFile ] ; then
		local lastRawString=`cat $tmpRebootFile`
		lastReboot=`date -d "$lastRawString" +"%F %T"`
	fi
	
	if [ "$_rebootEvent" = "0" ] ; then
		:
	else
		local currentSeconds=`date -d "$currentTime" +%s`
		
		if [ "$_lastRebootEventValue" = "" ] ; then
			_lastRebootEventValue="$_rebootEvent"
		fi
		
		if [ "$_lastRebootEventValue" = "$_rebootEvent" ] ; then
			:
		else			
			local newValue=`date -d "$(date +%F) $_rebootEvent" +"%F %T"`			
			local newValueS=`date -d "$newValue" +%s`
			_lastRebootEventValue="$_rebootEvent"
			if [ $newValueS -lt $currentSeconds ] ; then
				echo "$newValue" > $tmpRebootFile
				return
			fi
		fi
		
		local targetReboot=`date -d "$(date +%F) $_rebootEvent" +"%F %T"`
		local lastRebootSeconds=`date -d "$lastReboot" +%s`
		local targetRebootSeconds=`date -d "$targetReboot" +%s`
		
		echo "Current : $currentTime ($currentSeconds)"
		echo "Last Reboot : $lastReboot ($lastRebootSeconds)"
		echo "Target Reboot : $targetReboot ($targetRebootSeconds)"
		
		if [ $lastRebootSeconds -ne $targetRebootSeconds ] ; then
			if [ $currentSeconds -ge $targetRebootSeconds ] ; then
				Log "Executing system reboot event ($_rebootEvent)"
				echo "$targetReboot" > $tmpRebootFile
				Reboot
				exit
			fi
		fi
	fi
	
}

function Main() {
	
	declare -a _oldFiles
	declare -a _softwarePackagesInfo	
	
	local lastSyncTime=""
	local syncDuration=30
	local lastMemCheckTime=""
	local memCheckDuration=60
	local lastDumpDeviceInfoTime=""
	local dumpDeviceInfoDuration=600
	local lastFlashHeartbeatTime=""
	local flashHeartbeatDuration=60
	local lastCheckSoftwareUpdateTime=0
	local checkSoftwareUpdateDuration=60
	local lastUpdateDMHeartbeatTime=""
	local updateDMHeartbeatDuration=60
	local lastLogTransferTime=""
	local logTransferDuration=600
	local lastCheckSystemRebootTime=""
	local checkSystemRebootDuration=20
	
	if [ -f /apps/nexus2/checkproxy.sh ] ; then
		. /apps/nexus2/checkproxy.sh
	fi
	
	Log "Program Start"
	Log "Running Download Manager v$dmversion"
	Log "Deleting core dump files at /apps/core/"
	rm -rf /apps/core/*
	
	Log "Updating download manager's heartbeat (first-run) : $_dmHeartbeatFile"
	touch $_dmHeartbeatFile
	
	#sleep 15
	
	DumpDeviceInfo
	
	if [[ "$1" = *"nosleep"* ]] ; then
		:
	else	
		Log "Initial Sleep for 60 secs"
		sleep 60
	fi
	
	[[ -d $_tempPath ]] && : || mkdir $_tempPath
	
	#Delete previous heartbeat file
	Log "Delete previous heartbeat file"
	rm -rf "$_heartbeatFile"
	touch "$_heartbeatFile"
	
	if [ -e "$_baseApplicationPath/node.dat" ] ; then
		dos2unix $_baseApplicationPath/node.dat		
	fi
	
	local currentTime=`date +%s`
	
	
	
	while :
	do	
		currentTime=`date +%s`
		#Sync application content with local repository
		
		if [ "$lastUpdateDMHeartbeatTime" = "" ] ; then		
			Log "START UpdateDMHeartbeat"
			Log "Updating download manager's heartbeat : $_dmHeartbeatFile"
			touch $_dmHeartbeatFile
			lastUpdateDMHeartbeatTime=`date +%s`
			Log "Next update DM heartbeat in $updateDMHeartbeatDuration seconds"
			Log "END UpdateDMHeartbeat"
		elif [ $(($currentTime-$lastUpdateDMHeartbeatTime)) -ge $updateDMHeartbeatDuration ] ; then
			Log "START UpdateDMHeartbeat"
			Log "Updating download manager's heartbeat : $_dmHeartbeatFile"
			touch $_dmHeartbeatFile
			lastUpdateDMHeartbeatTime=`date +%s`
			Log "Next update DM heartbeat in $updateDMHeartbeatDuration seconds"
			Log "END UpdateDMHeartbeat"
		fi
		
		if [ -f "$_baseApplicationPath/nosplash.txt" ] ; then
			rm -rf "$_baseApplicationPath/nosplash.txt"
		fi
		
		#Delete servicelog file
		if [ -f /var/log/servicelog ] ; then
			rm -rf /var/log/servicelog
			Log "File servicelog deleted successfully"
		fi
		
		if [ -f /var/cron/log ] ; then
			rm -rf /var/cron/log
			Log "File cron log deleted successfully"
		fi

		if [ "$lastDumpDeviceInfoTime" = "" ] ; then
			Log "START DumpDeviceInfo"
			DumpDeviceInfo			
			lastDumpDeviceInfoTime=`date +%s`
			Log "Next device info dump in $dumpDeviceInfoDuration seconds"
			Log "END DumpDeviceInfo"
		elif [ $(($currentTime-$lastDumpDeviceInfoTime)) -ge $dumpDeviceInfoDuration ] ; then
			Log "START DumpDeviceInfo"
			DumpDeviceInfo
			lastDumpDeviceInfoTime=`date +%s`
			Log "Next device info dump in $dumpDeviceInfoDuration seconds"
			Log "END DumpDeviceInfo"
		fi
		
		if [ "$lastFlashHeartbeatTime" = "" ] ; then
			Log "START RunWatchdog"
			RunWatchdog
			lastFlashHeartbeatTime=`date +%s`
			Log "Next player watchdog in $flashHeartbeatDuration seconds"
			Log "END RunWatchdog"
		elif [ $(($currentTime-$lastFlashHeartbeatTime)) -ge $flashHeartbeatDuration ] ; then
			Log "START RunWatchdog"
			RunWatchdog
			lastFlashHeartbeatTime=`date +%s`
			Log "Next player watchdog in $flashHeartbeatDuration seconds"
			Log "END RunWatchdog"
		fi
		
		#Run Syncloop
		if [ "$lastSyncTime" = "" ] ; then
			Log "START SyncLoop"
			SyncLoop
			lastSyncTime=`date +%s`
			Log "Next sync in $syncDuration seconds"
			Log "END SyncLoop"
		elif [ $((currentTime-$lastSyncTime)) -ge $syncDuration ] ; then			
			Log "START SyncLoop"
			SyncLoop
			lastSyncTime=`date +%s`
			Log "Next sync in $syncDuration seconds"
			Log "END SyncLoop"
		fi
		
		syncDuration=$_syncInterval
		
		#Check for software updates
		if [ "$lastCheckSoftwareUpdateTime" = "" ] ; then
			Log "START CheckForSofwareUpdates"
			CheckForSofwareUpdates
			lastCheckSoftwareUpdateTime=`date +%s`
			Log "Next software update check in $checkSoftwareUpdateDuration seconds"
			Log "END CheckForSofwareUpdates"
		elif [ $(($currentTime-$lastCheckSoftwareUpdateTime)) -ge $checkSoftwareUpdateDuration ] ; then
			Log "START CheckForSofwareUpdates"
			CheckForSofwareUpdates
			lastCheckSoftwareUpdateTime=`date +%s`
			Log "Next software update check in $checkSoftwareUpdateDuration seconds"
			Log "END CheckForSofwareUpdates"
		fi
		
		if [ "$lastMemCheckTime" = "" ] ; then
			Log "START MemoryWatch"
			MemoryWatch
			lastMemCheckTime=`date +%s`
			Log "Next mem check in $memCheckDuration seconds"
			Log "END MemoryWatch"
		elif [ $(($currentTime-$lastMemCheckTime)) -ge $memCheckDuration ] ; then
			Log "START MemoryWatch"
			MemoryWatch
			lastMemCheckTime=`date +%s`
			Log "Next mem check in $memCheckDuration seconds"
			Log "END MemoryWatch"
		fi
		
		if [[ -f "$_baseApplicationPath/install-reboot" ]] ; then
			Log "Software Update requires reboot, rebooting now"
			rm -rf "$_baseApplicationPath/install-reboot"
			KillChrome
			Reboot
			exit
		fi
		
		
		if [ "$lastCheckSystemRebootTime" = "" ] ; then
			Log "START CheckSystemReboot"
			CheckSystemReboot
			lastCheckSystemRebootTime=`date +%s`
			Log "Next system reboot check in $checkSystemRebootDuration seconds"
			Log "END CheckSystemReboot"
		elif [ $(($currentTime-$lastCheckSystemRebootTime)) -ge $checkSystemRebootDuration ] ; then
			Log "START CheckSystemReboot"
			CheckSystemReboot
			lastCheckSystemRebootTime=`date +%s`
			Log "Next system reboot check in $checkSystemRebootDuration seconds"
			Log "END CheckSystemReboot"
		fi
		
		if [ "$lastLogTransferTime" = "" ] ; then
			Log "START TransferLogs"
			Log "Moving log file to $_logPath"
			cat $_templogpath/downloadmanagerlog.txt >> $_logPath/downloadmanagerlog.txt
			lastLogTransferTime=`date +%s`
			Log "Next log transfer in $logTransferDuration seconds"
			Log "END TransferLogs"
			Log "Log transferred" "true"
		elif [ $(($currentTime-$lastLogTransferTime)) -ge $logTransferDuration ] ; then
			Log "START TransferLogs"
			Log "Moving log file to $_logPath"
			cat $_templogpath/downloadmanagerlog.txt >> $_logPath/downloadmanagerlog.txt
			lastLogTransferTime=`date +%s`
			Log "Next log transfer in $logTransferDuration seconds"
			Log "END TransferLogs"
			Log "Log transferred" "true"
		fi
		sleep 5
	done
	
	echo "Program Exit"
}

#Begin program
Main $1
