#!/bin/bash
configfile1="/apps/nexus2/orientation_rotate.config"
configfile2="/apps/nexus2/orientation_file.config"

function Switch(){
	
	local rotatedirection="normal"
	local rotatedirectionint=""
	if [ "$1" != "" ] && [ "$2" != "" ] ; then
		echo "Saving configuration ($1) ($2)"
		echo "$1" > $configfile2
		echo "$2" > $configfile1
		
		rotatedirectionint="$2"
	elif [ -f $configfile1 ] ; then
		rotatedirectionint="`cat $configfile1`"
	else
		local screeninfo="$(curl -s -X GET -k https://127.0.0.1/api/v3/screen)"
		local screenrot=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).DVI1.current_rotation' "$screeninfo")
		if [ "$screenrot" = "" -o "$screenrot" = "undefined" ] ; then
			screenrot=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).VGA1.current_rotation' "$screeninfo")
		fi
		
		if [ "$screenrot" = "" -o "$screenrot" = "undefined" ] ; then
			screenrot="normal"
		fi
		
		rotatedirection="$screenrot"
	fi
	
	[[ "$rotatedirectionint" = "90" ]] && rotatedirection="right"
	[[ "$rotatedirectionint" = "270" ]] && rotatedirection="left"
	[[ "$rotatedirectionint" = "-90" ]] && rotatedirection="left"
	[[ "$rotatedirectionint" = "0" ]] && rotatedirection="normal"
	[[ "$rotatedirectionint" = "180" ]] && rotatedirection="inverted"
	
	if [ "$rotatedirection" = "left" ] || [ "$rotatedirection" = "right" ] ; then
		echo "Copying portrait file"
		cp -f /apps/nexus2/nexusmediaplayer-portrait.swf /apps/nexus2/nexusmediaplayer.swf
	else
		echo "Copying landscape file"
		cp -f /apps/nexus2/nexusmediaplayer-landscape.swf /apps/nexus2/nexusmediaplayer.swf
	fi
	
	
	echo "Rotating display...($rotatedirection)"
	output=$(curl -s -d "{\"DVI1\":{\"setting_rotation\":\"$rotatedirection\",\"setting_relation\":\"single\"},\"VGA1\":{\"setting_rotation\":\"$rotatedirection\",\"setting_relation\":\"single\"}}" -X PUT -k "https://127.0.0.1/api/v3/screen")
	
	if [ "$rotatedirectionint" = "" ] ; then
		[[ "$rotatedirection" = "right" ]] && rotatedirectionint=90
		[[ "$rotatedirection" = "left" ]] && rotatedirectionint=270
		[[ "$rotatedirection" = "normal" ]] && rotatedirectionint=0
		[[ "$rotatedirection" = "inverted" ]] && rotatedirectionint=180
	fi
	
	echo "$rotatedirectionint" > $configfile1
	chown user:user $configfile1
	chmod a+rw $configfile1
	
	killall -9 chrome
	
	echo "Done"
}

Switch "$@"