#!/bin/bash
_SYSTEMDIR="/apps/nexus2"
_SERVER=""
_REGISTRATIONPATH="integrationwebservices/edge300"

PopulateArguments()
{
	:
}

CopyFiles()
{
	echo "Is /nexusstorage present?"
	if [ -d /nexusstorage/ ] ; then		
		echo "yes"
		cp -f /nexusstorage/node.dat /apps/nexus2/node.dat
		cp -rf /nexusstorage/Logs /apps/nexus2/Logs
		cp -f /nexusstorage/version.inf /apps/nexus2/version.inf
	else
		echo "no"
	fi	

	cp -f "player/nexusmediaplayer.swf" "/apps/nexus2/nexusmediaplayer.swf"
	cp -f "scripts/downloadmanagerEdge300.sh" "/apps/nexus2/downloadmanageredge300.sh"	
	cp -f "scripts/getstatus.sh" "$_SYSTEMDIR/getstatus.sh"
	cp -f "scripts/nexuspfconf.sh" "$_SYSTEMDIR/nexuspfconf"
	cp -f "scripts/nexusrtconf.sh" "$_SYSTEMDIR/nexusrtconf"
	cp -f "scripts/nexusstatconf.sh" "$_SYSTEMDIR/nexusstatconf"
	cp -f "scripts/nexuswsconf.sh" "$_SYSTEMDIR/nexuswsconf"
	cp -f "scripts/policyfile.xml" "$_SYSTEMDIR/policyfile.xml"
	cp -f "scripts/remoteterminal.sh" "$_SYSTEMDIR/remoteterminal.sh"
	cp -f "scripts/servepolicyfile.sh" "$_SYSTEMDIR/servepolicyfile.sh"
	cp -f "scripts/startup.sh" "$_SYSTEMDIR/startup.sh"
	cp -f "scripts/ws.sh" "$_SYSTEMDIR/ws.sh"
	cp -f "scripts/logger.sh" "$_SYSTEMDIR/logger.sh"
	cp -f "scripts/rebootscript.sh" "$_SYSTEMDIR/rebootscript.sh"
	cp -f "scripts/dmholder.sh" "$_SYSTEMDIR/dmholder.sh"
	cp -f "scripts/appspacemonitor.sh" "$_SYSTEMDIR/appspacemonitor.sh"
	cp -f "scripts/storagecontroller.sh" "$_SYSTEMDIR/storagecontroller.sh"
	cp -f "scripts/node" "$_SYSTEMDIR/node"
	cp -f "scripts/admholder.sh" "$_SYSTEMDIR/admholder.sh"
	cp -f "scripts/killallappspaceprocess.sh" "$_SYSTEMDIR/killallappspaceprocess.sh"
	
	cp -f "scripts/crontab" "$_SYSTEMDIR/crontab"
	cp -f "patch/cursor/transp" "$_SYSTEMDIR/transp"
	cp -f "patch/cursor/left_ptr_backup" "$_SYSTEMDIR/left_ptr_backup"
	cp -f "patch/functionkeys/keymap" "$_SYSTEMDIR/keymap"
}

ConfigureFiles()
{
	dos2unix "/apps/nexus2/downloadmanageredge300.sh"
	chmod 777 "/apps/nexus2/downloadmanageredge300.sh"
	
	dos2unix "$_SYSTEMDIR/getstatus.sh"
	chmod 777 "$_SYSTEMDIR/getstatus.sh"
	dos2unix "$_SYSTEMDIR/nexuspfconf"
	chmod 777 "$_SYSTEMDIR/nexuspfconf"
	dos2unix "$_SYSTEMDIR/nexusrtconf"
	chmod 777 "$_SYSTEMDIR/nexusrtconf"
	dos2unix "$_SYSTEMDIR/nexusstatconf"
	chmod 777 "$_SYSTEMDIR/nexusstatconf"
	dos2unix "$_SYSTEMDIR/nexuswsconf"
	chmod 777 "$_SYSTEMDIR/nexuswsconf"
	dos2unix "$_SYSTEMDIR/policyfile.xml"
	dos2unix "$_SYSTEMDIR/remoteterminal.sh"
	chmod 777 "$_SYSTEMDIR/remoteterminal.sh"
	dos2unix "$_SYSTEMDIR/servepolicyfile.sh"
	chmod 777 "$_SYSTEMDIR/servepolicyfile.sh"
	dos2unix "$_SYSTEMDIR/startup.sh"
	chmod 777 "$_SYSTEMDIR/startup.sh"
	dos2unix "$_SYSTEMDIR/rebootscript.sh"
	chmod 777 "$_SYSTEMDIR/rebootscript.sh"
	dos2unix "$_SYSTEMDIR/ws.sh"
	chmod 777 "$_SYSTEMDIR/ws.sh"
	dos2unix "$_SYSTEMDIR/logger.sh"
	chmod 777 "$_SYSTEMDIR/logger.sh"
	dos2unix "$_SYSTEMDIR/dmholder.sh"
	chmod 777 "$_SYSTEMDIR/dmholder.sh"
	dos2unix "$_SYSTEMDIR/appspacemonitor.sh"
	chmod 777 "$_SYSTEMDIR/appspacemonitor.sh"
	dos2unix "$_SYSTEMDIR/storagecontroller.sh"
	chmod 777 "$_SYSTEMDIR/storagecontroller.sh"
	dos2unix "$_SYSTEMDIR/crontab"	
	
	chmod 777 "$_SYSTEMDIR/keymap"
	chmod 777 "$_SYSTEMDIR/node"
	dos2unix "$_SYSTEMDIR/admholder.sh"
	chmod 777 "$_SYSTEMDIR/admholder.sh"
	dos2unix "$_SYSTEMDIR/killallappspaceprocess.sh"
	chmod 777 "$_SYSTEMDIR/killallappspaceprocess.sh"
	
	mv -f "$_SYSTEMDIR/nexuspfconf" "/etc/xinetd.d/nexuspfconf"
	mv -f "$_SYSTEMDIR/nexusrtconf" "/etc/xinetd.d/nexusrtconf"
	mv -f "$_SYSTEMDIR/nexusstatconf" "/etc/xinetd.d/nexusstatconf"
	mv -f "$_SYSTEMDIR/nexuswsconf" "/etc/xinetd.d/nexuswsconf"
	
	cp -f "$_SYSTEMDIR/left_ptr_backup" /usr/share/icons/default/cursors/left_ptr
	rm -f /usr/share/icons/default/cursors/left_ptr_backup
	
	local ts=$(cat /scripts/startxfce4)
	ts=$(echo "$ts" | sed 's|nexusstorage|apps/nexus2|g')
	echo "$ts" > /scripts/startxfce4
}

ConfigureXinetd()
{
	local filetocheck="/etc/services"

	if [ "$filetocheck" != "" ] ;then
		check=""
		check=`cat "$filetocheck" | grep nexusrt`
		if [ "$check" = "" ] ; then
			echo "nexusrt 55535/tcp" >> "$filetocheck"
		fi
		check=""
		check=`cat "$filetocheck" | grep nexusstat`
		if [ "$check" = "" ] ; then
			echo "nexusstat 55536/tcp" >> "$filetocheck"
		fi
		check=""
		check=`cat "$filetocheck" | grep nexusws`
		if [ "$check" = "" ] ; then
			echo "nexusws 55537/tcp" >> "$filetocheck"
		fi
		check=""
		check=`cat "$filetocheck" | grep nexuspf`
		if [ "$check" = "" ] ; then
			echo "nexuspf 843/tcp" >> "$filetocheck"
		fi
	fi
}

ConfigureFlashTrust()
{
	local trustpath="/etc/adobe/FlashPlayerTrust/"
	local trustfile="trust.cfg"

	if [ -d "$trustpath" ]; then
		:
	else
		mkdir -p "$trustpath"
	fi

	echo "/apps/nexus2/" > "$trustpath""$trustfile"
}

ConfigureSTARTXFCE()
{
	local sourcefile="/scripts/startxfce4"
}

Finalize()
{
	
	if [ -d /nexusstorage ] ; then
		touch "/nexusstorage/install-reboot"
		echo "externalstorage=true" >> /apps/nexus2/node.dat
		rm -f /apps/nexus2/DMscript.txt
		rm -f /apps/nexus2/DMapptimestamp.js
		rm -rf /nexusstorage/contentrepo
	else
		touch "/apps/nexus2/install-reboot"
	fi
}

GetDeviceFirmware()
{
	REPLY=""
	
	local dfirmware=`cat /scripts/cisco_env.sh | grep FS_VERSION`
	dfirmware=`echo $dfirmware | sed 's|export FS_VERSION=||'`
	
	REPLY="$dfirmware"
}

Do1080iPatch()
{
	local wfodler="$1"
	
	if [ -f "$wfodler/1080ipatch/1080iauto.tar.gz" ] ; then
		tar zxvf "$wfodler/1080ipatch/1080iauto.tar.gz" -C /
	fi
}

DoFlashPatch()
{	
	rm -f /usr/lib/mozilla/plugins/libflashplayer.so
	cp -f patch/flashpatch/libflashplayer.so /usr/lib/mozilla/plugins/
}

DoShowIPPatch()
{
	local wfodler="$1"
	
	if [ -f "$wfodler/showippatch/ce300_showip.tar.gz" ] ; then
		tar zxvf "$wfodler/showippatch/ce300_showip.tar.gz" -C /
	fi	
	
}

DoVLCPatch()
{
	local wfodler="$1"
	
	rm /apps/localconfig/student/.mozilla/plugins/libvlcplugin.so -f 
	rm /usr/lib/mozilla/plugins/libvlcplugin.so -f
	rm /usr/local/cisco/lib/*vlc* -r -f
	
	tar -jxf patch/vlcpatch/vlc-lib.tar.bz2 -C /
	cp patch/vlcpatch/libvlcplugin.so /usr/lib/mozilla/plugins/ -f
}

DoUnClutterPatch()
{
	rm -rf "$_SYSTEMDIR/unclutter/"
	mkdir "$_SYSTEMDIR/unclutter/"
	tar -xvf patch/cursor/unclutter.tar -C "$_SYSTEMDIR/unclutter/"
}

ConfigureFirmwarePatch()
{
	local workingpatchfolder="patch"

	Do1080iPatch "$workingpatchfolder"
	DoFlashPatch "$workingpatchfolder"
	DoShowIPPatch "$workingpatchfolder"
	DoVLCPatch "$workingpatchfolder"
	DoUnClutterPatch "$workingpatchfolder"
}

GetServerAddress()
{
	_SERVER=""
	local count=0
	while read line
	do
		if [ "$count" = "2" ]; then
			_SERVER="$line"
			break
		fi
		count=$(($count+1))
	done < "/apps/nexus2/node.dat"
	
}

ConfigureChromeAllowLocalAccess()
{
	local tempfile="/apps/nexus2/tempstartxfce4"
	rm -rf "$tempfile"
	touch "$tempfile"
	while read line
	do
		local docheck=`echo "$line" | grep /opt/chromium/chrome`
		if [ "$docheck" = "" ]; then
			echo "$line" >> "$tempfile"
		else
			local newline=`echo "$line" | sed 's|/opt/chromium/chrome --no-first-run|/opt/chromium/chrome --allow-file-access-from-files --no-first-run|'`
			echo "$newline" >> "$tempfile"
		fi
	done < "/scripts/startxfce4"
	
	cp -f $tempfile "/scripts/startxfce4"
	rm -f $tempfile
	chmod 777 "/scripts/startxfce4"
}

ConfigureRS232()
{
	if [ -f "patch/rs232/rs232" ] ; then
		cp -f patch/rs232/rs232 /apps/nexus2/rs232
		cp -f patch/rs232/rs232holder /apps/nexus2/rs232holder
		chmod 777 /apps/nexus2/rs232
		chmod 777 /apps/nexus2/rs232holder
	fi
}

ConfigureNodeProject()
{
	if [ -d nodescripts ] ; then
		if [ -d /apps/nexus2/nodescripts ] ; then
			:
		else
			mkdir /apps/nexus2/nodescripts
		fi
		
		if [ -d /apps/nexus2/nodescripts/appspacenode ] ; then
			:
		else
			mkdir /apps/nexus2/nodescripts/appspacenode
		fi
		
		cp -rf nodescripts/appspacenode/* /apps/nexus2/nodescripts/appspacenode/
	fi
}

Start()
{
	
	if [ -f setup.300.sh ] ; then
		dos2unix setup.300.sh && chmod 777 setup.300.sh && /bin/bash setup.300.sh "$@"
		exit
	fi
	
	PopulateArguments $*
	#GetServerAddress
	CopyFiles
	ConfigureFiles
	ConfigureXinetd
	ConfigureFlashTrust
	ConfigureSTARTXFCE
	ConfigureChromeAllowLocalAccess
	ConfigureRS232
	ConfigureNodeProject
	Finalize
}

Start "$@"